import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.security.GeneralSecurityException;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
 
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.X509KeyManager; 
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSocket;


public class TLS13clientTest {
	
	private static SSLContext sc = null;
	private static SSLSocketFactory sslsocketfactory = null;
	
	public static void main(String[] arstring) throws GeneralSecurityException,  IOException {

		System.setProperty("javax.net.debug", "all");
		java.lang.System.setProperty("sun.security.ssl.allowUnsafeRenegotiation", "true");

		try {
			startTLSclient("127.0.0.1", "12350");
		}
		catch (Exception e) {
			System.out.println(e.getMessage());
        }
	}
		
	
	private static void startTLSclient(String serv_ip, String serv_port) throws IOException {
		
		if(serv_ip == null || serv_port == null) {
			System.out.println("startTLSclient: server ip_address or port not defined");
			return;
		}

		sslsocketfactory = (SSLSocketFactory) SSLSocketFactory.getDefault();
		SSLSocket sslsocket = null;
		
		try 
		{
			System.out.println("startTLSclient 1: " + serv_ip + ":" + Integer.parseInt(serv_port));
			sslsocket = (SSLSocket) sslsocketfactory.createSocket(serv_ip,Integer.parseInt(serv_port));
			
			System.out.println("startTLSclient 2: SSLSocket created");
//			final String[] enabledCipherSuites = { "TLS_DHE_DSS_WITH_AES_128_CBC_SHA" };
//			sslsocket.setEnabledCipherSuites(enabledCipherSuites);
			String[] sp = sslsocket.getSupportedProtocols();
			String[] ss = sslsocket.getEnabledCipherSuites();
			sslsocket.setEnabledCipherSuites(ss);

			System.out.println("SupportedProtocols");
			for(int i=0;i<sp.length;i++){
				System.out.println(sp[i]);
			}

//			String[] spnew = {"TLSv1.2"};
//			sslserversocket.setEnabledProtocols(spnew);
			
			
/*			
			System.out.println("Enabled ciphers: " + Arrays.toString(sslserversocket.getEnabledCipherSuites()));
*/
			
			System.out.println("startTLSclient: Start TLS handshake");
			sslsocket.startHandshake();
			
			InputStream inputstream = sslsocket.getInputStream();
			OutputStream outputstream = sslsocket.getOutputStream();
	
			InputStreamReader inputstreamreader = new InputStreamReader(
					inputstream);
			BufferedReader bufferedreader = new BufferedReader(
					inputstreamreader);

			OutputStreamWriter outputstreamwriter = new OutputStreamWriter(
					outputstream);
			BufferedWriter bufferedwriter = new BufferedWriter(
					outputstreamwriter);

			System.out.println("startTLSclient: send test string");
			bufferedwriter.write("test string");
			bufferedwriter.flush();

			String sslStr;
			while (true) {
				sslStr = bufferedreader.readLine();
				System.out.println(sslStr);
				System.out.flush();
				if(sslStr.startsWith("close")){
					System.out.println("startTLSclient: received close string");
					break;
				}
			}

			
			System.out.println("startTLSclient: close in out streams");
			bufferedwriter.close();
			outputstreamwriter.close();
			outputstream.close();
			bufferedreader.close();
			inputstreamreader.close();
			inputstream.close();

		}
		catch (Exception err) {
			System.out.println("startTLSclient: " + err);
			err.printStackTrace();
		}
		finally
		{
			if(sslsocket != null ) { 
				System.out.println("startTLSclient: Connection to " + sslsocket.getRemoteSocketAddress() + " closed");
				sslsocket.close();
			}
		}
	}

}