import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.security.GeneralSecurityException;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
 
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.X509KeyManager; 
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSocket;


public class TLSclientTry {
	
	private static SSLSocketFactory sslsocketfactory = null;
	
	public static void main(String[] arstring) throws GeneralSecurityException,  IOException {

		System.setProperty("javax.net.debug", "all");
		java.lang.System.setProperty("sun.security.ssl.allowUnsafeRenegotiation", "true");
		
		sslsocketfactory = (SSLSocketFactory) SSLSocketFactory.getDefault();
//		sslsocketfactory = (SSLSocketFactory) sc.getSocketFactory();
		startTLSclient("127.0.0.1", "4545");

	}
		
	
	private static void startTLSclient(String serv_ip, String serv_port) throws IOException {
		
		if(serv_ip == null || serv_port == null) {
			System.out.println("startTLSclient: server ip_address or port not defined");
			return;
		}

		SSLSocket sslsocket = null;
		
		try 
		{
			System.out.println("startTLSclient 1: " + serv_ip + ":" + Integer.parseInt(serv_port));
			sslsocket = (SSLSocket) sslsocketfactory.createSocket(serv_ip,Integer.parseInt(serv_port));
			
			System.out.println("startTLSclient 2: SSLSocket created");

			String[] spnew = {"TLSv1.3"};
			sslsocket.setEnabledProtocols(spnew);
			
			
			
			System.out.println("startTLSclient: Start TLS handshake");
			sslsocket.startHandshake();
			
			System.out.println("startTLSclient: Start TLS handshake");
			
		}
		catch (Exception err) {
			System.out.println("startTLSclient: " + err);
			err.printStackTrace();
		}
		finally
		{
			if(sslsocket != null ) { 
				System.out.println("startTLSclient: Connection to " + sslsocket.getRemoteSocketAddress() + " closed");
				sslsocket.close();
			}
		}
	}

}