package ru.ispras.telecomtesk.tlsv13.TestsClient.MainTests;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import jatva.lang.GraphExplorer;
import java.security.cert.Certificate;
import java.util.Date;
import java.util.Random;
import java.lang.invoke.MethodHandles;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TlsKeystore;
import ru.ispras.telecomtesk.tlsv13.TLSclientSpecification.*;

@jatva.lang.annotation.ScenarioClass
public 
class SendBadAlert
    extends jatva.lang.TestingModel
{

    @jatva.lang.annotation.JTSInternal
    public SendBadAlert() {}

    @Override
    @jatva.lang.annotation.JTSInternal
    public jatva.lang.AbstractAction _ts_initialize()
    {
        return new jatva.lang.SimpleAction( 0 /* connect */ );
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected int _ts_getMaxMethodNumber()
    { return 1; }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected jatva.lang.AbstractAction _ts_nextDeclared( int currentMethodNumber )
    {
        switch( currentMethodNumber )
        {
            case 0: return new jatva.lang.SimpleAction( 1 /* MalformedAlert */ );
            default:
                return super._ts_nextDeclared( currentMethodNumber );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected void _ts_executeDeclared( jatva.lang.AbstractAction _par_action )
    {
        switch( _par_action.method() )
        {
            case 0:
                _ts_partialExecute_connect( _par_action );
                break;
            case 1:
                _ts_partialExecute_MalformedAlert( _par_action );
                break;
            default:
                super._ts_executeDeclared( _par_action );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected String _ts_getScenMethodName( int method_number )
    {
        switch( method_number )
        {
            case 0:
                return "connect";
            case 1:
                return "MalformedAlert";
            default:
                return super._ts_getScenMethodName( method_number );
        }
    }

    public
    TLSClientScenProp scenParam;

    public
    String scenName;

    private
    String currentClassName;

    public
    SendBadAlert( String logFileName)
    {
        super( );
        DebugInfo.debugLevel = 4;
        DebugInfo.maxDumpSize = 400;
        currentClassName = MethodHandles.lookup(  ).lookupClass(  ).getSimpleName(  );
        scenParam = new TLSClientScenProp( logFileName, currentClassName );

        TLSConnectionSelector sel = new TLSConnectionSelector( null, null, 0, 0 );
        scenParam.current_connection = new TLSConnection( sel, ConnectionRole.SERVER );

        GraphExplorer xxx = new DFSMExplorer(  );
        xxx.setMaximumNumberOfTransitions( 5000 );
        xxx.setNumberOfNoncriticalErrorsToIgnore( 5000 );
        setTestEngine( xxx );
    }

    @jatva.lang.annotation.StateBlock
    public 
    Object _ts_state()
    {
        try
        {
            return new Integer( 1 );
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.GenStateCalculationException
                ( this
                , _lv_error
                );
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "connect" )
    protected void _ts_partialExecute_connect
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "connect", _par_parameter_action );
        try
        {
            {
                scenName = " Connect ";
                DebugInfo.printMessageWithSeparator( 4, "!!!scenario try," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessageWithSeparator( 4, "!already connected" );
                    return;
                }
                scenParam.connectCounter++;
                DebugInfo.printMessage( 1, "scenario start," + scenName );
                try
                {
                    scenParam.target.connect( scenParam.current_connection );
                }
                catch( jatva.lang.TestException terr )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario TestException:" + scenName + terr );
                    scenParam.target.disconnect(  );
                    throw terr;
                }
                catch( Exception err )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario failed:" + scenName + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadAlert"
                        , "connect"
                        , "scenario failed" + scenName + err
                        );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "connect"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "MalformedAlert" )
    protected void _ts_partialExecute_MalformedAlert
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "MalformedAlert", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " MalformedAlert ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                ChangeCipher msg = new ChangeCipher(  );
                scenParam.target.waitFatalAlert = 47;

                Exception err = scenParam.msgSetContentAndSend( TLSContentType.ALERT, msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "MalformedAlert"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    public
    void finalize( )
    {
        try
        {
            DebugInfo.printMessage( 1, "===finalize===" );
            scenParam.target.stop(  );
        }
        catch( Exception err )
        {
            DebugInfo.printMessage( 1, "===Error! StopServer: " + err );
        }
    }


    public static
    void main( String[] args)
    {

        String fileName = "connectInfo_java.txt";
        if( args.length > 0 )
            fileName = args[0];

        start( fileName );
    }


    public static
    void start( String fileName)
    {

        SendBadAlert scen = new SendBadAlert( fileName );

        Date dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "start test " + scen.currentClassName + " " + dt1.toString(  ) );
        scen.run(  );
        scen.finalize(  );
        dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "end test: " + dt1.toString(  ) + " testCounter " + scen.scenParam.connectCounter + " scenarioCounter " + scen.scenParam.scenarioCounter );
        scen.scenParam.logFile.close(  );
    }

}
