package ru.ispras.telecomtesk.tlsv13.TestsClient.MainTests;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import jatva.lang.GraphExplorer;
import java.security.cert.Certificate;
import java.util.Date;
import java.util.Random;
import java.lang.invoke.MethodHandles;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TlsKeystore;
import ru.ispras.telecomtesk.tlsv13.TLSclientSpecification.*;

@jatva.lang.annotation.ScenarioClass
public 
class SendBadChangeCipher
    extends jatva.lang.TestingModel
{

    @jatva.lang.annotation.JTSInternal
    public SendBadChangeCipher() {}

    @Override
    @jatva.lang.annotation.JTSInternal
    public jatva.lang.AbstractAction _ts_initialize()
    {
        return new jatva.lang.SimpleAction( 0 /* connect */ );
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected int _ts_getMaxMethodNumber()
    { return 8; }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected jatva.lang.AbstractAction _ts_nextDeclared( int currentMethodNumber )
    {
        switch( currentMethodNumber )
        {
            case 0: return new jatva.lang.SimpleAction( 1 /* ServerHelloRetry */ );
            case 1: return new jatva.lang.SimpleAction( 2 /* ServerHello */ );
            case 2: return new AbstractAction_ChangeCipher();
            case 3: return new jatva.lang.SimpleAction( 4 /* EncryptedExtensions */ );
            case 4: return new jatva.lang.SimpleAction( 5 /* Certificate */ );
            case 5: return new jatva.lang.SimpleAction( 6 /* CertificateVerify */ );
            case 6: return new jatva.lang.SimpleAction( 7 /* Finished */ );
            case 7: return new jatva.lang.SimpleAction( 8 /* ApplicationData */ );
            default:
                return super._ts_nextDeclared( currentMethodNumber );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected void _ts_executeDeclared( jatva.lang.AbstractAction _par_action )
    {
        switch( _par_action.method() )
        {
            case 0:
                _ts_partialExecute_connect( _par_action );
                break;
            case 1:
                _ts_partialExecute_ServerHelloRetry( _par_action );
                break;
            case 2:
                _ts_partialExecute_ServerHello( _par_action );
                break;
            case 3:
                _ts_partialExecute_ChangeCipher( _par_action );
                break;
            case 4:
                _ts_partialExecute_EncryptedExtensions( _par_action );
                break;
            case 5:
                _ts_partialExecute_Certificate( _par_action );
                break;
            case 6:
                _ts_partialExecute_CertificateVerify( _par_action );
                break;
            case 7:
                _ts_partialExecute_Finished( _par_action );
                break;
            case 8:
                _ts_partialExecute_ApplicationData( _par_action );
                break;
            default:
                super._ts_executeDeclared( _par_action );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected String _ts_getScenMethodName( int method_number )
    {
        switch( method_number )
        {
            case 0:
                return "connect";
            case 1:
                return "ServerHelloRetry";
            case 2:
                return "ServerHello";
            case 3:
                return "ChangeCipher";
            case 4:
                return "EncryptedExtensions";
            case 5:
                return "Certificate";
            case 6:
                return "CertificateVerify";
            case 7:
                return "Finished";
            case 8:
                return "ApplicationData";
            default:
                return super._ts_getScenMethodName( method_number );
        }
    }

    public
    TLSClientScenProp scenParam;

    public
    String scenName;

    private
    String currentClassName;

    private
    short[] serverSupportedCipherSuites;

    private
    NamedGroup[] serverSupportedNamedGroups;

    public
    SendBadChangeCipher( String logFileName)
    {
        super( );
        DebugInfo.debugLevel = 4;
        DebugInfo.maxDumpSize = 400;
        currentClassName = MethodHandles.lookup(  ).lookupClass(  ).getSimpleName(  );
        scenParam = new TLSClientScenProp( logFileName, currentClassName );

        TLSConnectionSelector sel = new TLSConnectionSelector( null, null, 0, 0 );
        scenParam.current_connection = new TLSConnection( sel, ConnectionRole.SERVER );
        serverSupportedCipherSuites = new short[]{
            TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )
            , TLSCipherSuite.TLS_AES_256_GCM_SHA384.getValue(  )}
        ;
        serverSupportedNamedGroups = new NamedGroup[]{
            NamedGroup.SECP256R1
            , NamedGroup.FFDHE2048
            , NamedGroup.SECP384R1
            , NamedGroup.FFDHE3072}
        ;

        GraphExplorer xxx = new DFSMExplorer(  );
        xxx.setMaximumNumberOfTransitions( 5000 );
        xxx.setNumberOfNoncriticalErrorsToIgnore( 5000 );
        setTestEngine( xxx );
    }

    @jatva.lang.annotation.StateBlock
    public 
    Object _ts_state()
    {
        try
        {
            return scenParam.target.getCurrentState(  );
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.GenStateCalculationException
                ( this
                , _lv_error
                );
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "connect" )
    protected void _ts_partialExecute_connect
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "connect", _par_parameter_action );
        try
        {
            {
                scenName = " Connect ";
                DebugInfo.printMessageWithSeparator( 4, "!!!scenario try," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessageWithSeparator( 4, "!already connected" );
                    return;
                }
                scenParam.connectCounter++;
                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );
                try
                {
                    scenParam.target.connect( scenParam.current_connection );
                }
                catch( jatva.lang.TestException terr )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario TestException:" + scenName + terr );
                    scenParam.target.disconnect(  );
                    throw terr;
                }
                catch( Exception err )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario failed:" + scenName + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadChangeCipher"
                        , "connect"
                        , "scenario failed" + scenName + err
                        );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "connect"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHelloRetry" )
    protected void _ts_partialExecute_ServerHelloRetry
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHelloRetry", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHelloRetry ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLO )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;

                NamedGroup[] serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( serNmGrp != null )
                {
                    DebugInfo.printMessage( 1, "No need ServerHelloRetry" );
                    return;
                }

                short[] cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );
                serNmGrp = curHPrm.chooseRetryNamedGroup( serverSupportedNamedGroups );
                if( cs == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable CipherSuites" );
                    checkFlag = true;
                }
                if( serNmGrp == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                    checkFlag = true;
                }
                if( scenParam.target.last_client_hello == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! last_client_hello == null" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadChangeCipher"
                        , "ServerHelloRetry"
                        );
                }

                TLSExtension hl_ext_sv = new SupportedVersionsExt( new ProtocolVersion( 0x03, 0x04 ) );

                TLSExtension hl_ext_ks = new KeyShareHelloRetry( serNmGrp[0] );

                byte[] dataId = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8}
                ;

                CookieExt hl_ext_ck = new CookieExt( dataId );

                HelloRetryRequest msg = null;
                msg = new HelloRetryRequest( scenParam.target.last_client_hello.sessionID, cs );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_ck );
                msg.addExtension( hl_ext_ks );
                DebugInfo.printMessage( 1, "print HelloRetryRequest" );
                msg.print(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHelloRetry"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHello" )
    protected void _ts_partialExecute_ServerHello
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHello", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHello ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLO) && (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLOResume) )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;

                short[] cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );

                NamedGroup[] serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( scenParam.localks == null )
                {
                    DebugInfo.printMessage( 3, "Error!!! local Keystore not found" );
                    checkFlag = true;
                }
                if( cs == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable CipherSuites" );
                    checkFlag = true;
                }
                if( serNmGrp == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                    checkFlag = true;
                }
                if( scenParam.target.last_client_hello == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! last_client_hello == null" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadChangeCipher"
                        , "ServerHello"
                        );
                }
                DebugInfo.printMessage( 3, "local Keystore found" );
                TlsKeystore.getCertificate( scenParam.localks, curHPrm );
                curHPrm.generateServerKeyPair( serNmGrp[0] );

                TLSExtension hl_ext_sv = new SupportedVersionsExt( new ProtocolVersion( 0x03, 0x04 ) );

                TLSExtension hl_ext_ks = new KeyShareServerHello( curHPrm.serverKeyShare );

                Hello msg = null;
                msg = new Hello( scenParam.target.last_client_hello.sessionID, cs );
                msg.setTypeServerHello(  );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_ks );
                DebugInfo.printMessage( 1, "print ServerHello" );
                msg.print(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHello"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    @jatva.lang.annotation.JTSInternal
    protected class AbstractAction_ChangeCipher
        extends jatva.lang.AbstractAction
    {
        @jatva.lang.annotation.JTSInternal
        int choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        int next_value_choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ChangeCipher()
        {
            super( 3, 1, 0 );
        }

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ChangeCipher( AbstractAction_ChangeCipher _par_r )
        {
            super( _par_r );
            choice_1_0 = _par_r.choice_1_0;
            next_value_choice_1_0 = _par_r.next_value_choice_1_0;
        }

        @Override
        @jatva.lang.annotation.JTSInternal
        public Object clone()
        {
            return new AbstractAction_ChangeCipher( this );
        }
    }

    @jatva.lang.annotation.ScenarioMethod( jtsName = "ChangeCipher" )
    protected void _ts_partialExecute_ChangeCipher
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ChangeCipher", _par_parameter_action );
        AbstractAction_ChangeCipher _lv_action = (AbstractAction_ChangeCipher)_par_parameter_action;
        jatva.lang.AbstractAction.IterationFlags _lv_tmp_flags =
            new jatva.lang.AbstractAction.IterationFlags( _lv_action );
        boolean _lv_tmp = false;
        jatva.lang.DummyClass.dummy( _lv_tmp );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ChangeCipherPlain ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ServerHello )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = new byte[1];
                _lv_tmp_flags.setUsage( 0 );
                if( !(_lv_action.isIterationInitialized( 0 )) )
                {
                    _lv_action.choice_1_0 = 0;
                    if( _lv_action.choice_1_0 + 1 >= 6 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                else if( _lv_action.isIterationMove( 0 ) )
                {
                    _lv_action.choice_1_0++;
                    if( _lv_action.choice_1_0 + 1 >= 6 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                _lv_registrar.registerIterationVariableValue
                    ( jatva.tracer.ValueKind.CHOICE_ITERATION_VARIABLE
                    , "int"
                    , "choice_1"
                    , true
                    , _lv_action.choice_1_0
                    );
                switch( _lv_action.choice_1_0 )
                {
                    case 1:
                        {
                            data[0] = 0;
                            DebugInfo.printMessage( 1, "ChangeCipher flag: " + data[0] );
                        }

                        break;
                    case 2:
                        {
                            data[0] = 3;
                            DebugInfo.printMessage( 1, "ChangeCipher flag: " + data[0] );
                        }

                        break;
                    case 3:
                        {
                            data[0] = (byte)0xff;
                            DebugInfo.printMessage( 1, "ChangeCipher flag: " + data[0] );
                        }

                        break;
                    case 4:
                        {
                            data = new byte[0];
                            DebugInfo.printMessage( 1, "ChangeCipher flag: null" );
                        }

                        break;
                    case 5:
                        {
                            data = new byte[2];
                            data[0] = 1;
                            data[1] = 1;
                            DebugInfo.printMessage( 1, "ChangeCipher flag: {1,1}" );
                        }

                        break;
                    default:
                        {
                            data[0] = 1;
                            DebugInfo.printMessage( 1, "ChangeCipher right flag: " + data[0] );
                        }

                        break;
                }
                scenParam.target.waitFatalAlert = 10;

                RecordLayer tlsmsg = new RecordLayer( TLSContentType.CHANGE_CIPHER_SPEC, data );
                tlsmsg.initContent( 1 );
                tlsmsg.content[0] = data;
                scenParam.target.mayNoResponse = true;

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ChangeCipher"
                , _lv_error
                );
        }
        finally
        {
            _lv_action.retrieveFlags( _lv_tmp_flags );
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "EncryptedExtensions" )
    protected void _ts_partialExecute_EncryptedExtensions
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "EncryptedExtensions", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " EncryptedExtensions ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ServerHello )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                NamedGroup[] sg = {
                    NamedGroup.FFDHEtest
                    , NamedGroup.FFDHE2048
                    , NamedGroup.SECP256R1}
                ;

                SupportedGroupsExt hl_ext_sg = new SupportedGroupsExt( sg );

                EncryptedExtensions msg = new EncryptedExtensions(  );
                msg.addExtension( hl_ext_sg );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "EncryptedExtensions"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Certificate" )
    protected void _ts_partialExecute_Certificate
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Certificate", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Certificate ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_EncryptedExtensions )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                HMCertificate msg = new HMCertificate(  );

                Certificate lcert = scenParam.current_connection.getHandshakeParams(  ).localCert;
                if( lcert != null )
                {
                    DebugInfo.printMessage( 3, "local certificate found" );

                    byte[][] chain = TlsKeystore.getCertificateChainEncoded( scenParam.localks, lcert );
                    if( chain != null )
                        for( 
                        int i = 0; i < chain.length; i++)
                        msg.addCertificate( new CertificateEntry( chain[i] ) );

                    else
                        msg.addCertificate( new CertificateEntry( new byte[0] ) );

                }
                else
                {
                    DebugInfo.printMessage( 3, "Error!!! Local certificate not found" );
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadChangeCipher"
                        , "Certificate"
                        );
                }

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Certificate"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "CertificateVerify" )
    protected void _ts_partialExecute_CertificateVerify
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "CertificateVerify", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " CertificateVerify ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ServerCertificate )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                CertificateVerify msg = new CertificateVerify( scenParam.current_connection, scenParam.localks, scenParam.localKeystorePwd );
                if( (msg.alg == null) || (msg.getSignature(  ) == null) )
                {
                    DebugInfo.printMessageWithSeparator( 1, "Error!!! signature" );
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadChangeCipher"
                        , "CertificateVerify"
                        );
                }

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "CertificateVerify"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Finished" )
    protected void _ts_partialExecute_Finished
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Finished", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Finished ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ServerCertificateVerify )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                Finished msg = null;
                try
                {
                    msg = new Finished( scenParam.current_connection, MessageDirection.getMessageDirection( scenParam.current_connection.localRole, TLSDirection.SEND ) );
                }
                catch( Exception err )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "SendBadChangeCipher"
                        , "Finished"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Finished"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ApplicationData" )
    protected void _ts_partialExecute_ApplicationData
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ApplicationData", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Application ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.isHandshakeComplete(  ) )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                ApplicationData msg = new ApplicationData( scenParam.applicationDataString.getBytes(  ) );

                Exception err = scenParam.msgSetLargeContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenParam.target.waitFatalAlert = 10;
                scenParam.target.disconnectWithSendAlert = 0;
                scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ApplicationData"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    public
    void finalize( )
    {
        try
        {
            DebugInfo.printMessage( 1, "===finalize===" );
            scenParam.target.stop(  );
        }
        catch( Exception err )
        {
            DebugInfo.printMessage( 1, "===Error! StopServer: " + err );
        }
    }


    public static
    void main( String[] args)
    {

        String fileName = "connectInfo_java.txt";
        if( args.length > 0 )
            fileName = args[0];

        start( fileName );
    }


    public static
    void start( String fileName)
    {

        SendBadChangeCipher scen = new SendBadChangeCipher( fileName );

        Date dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "start test " + scen.currentClassName + " " + dt1.toString(  ) );
        scen.run(  );
        scen.finalize(  );
        dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "end test: " + dt1.toString(  ) + " testCounter " + scen.scenParam.connectCounter + " scenarioCounter " + scen.scenParam.scenarioCounter );
        scen.scenParam.logFile.close(  );
    }

}
