package ru.ispras.telecomtesk.tlsv13.TestsClient.MainTests;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import jatva.lang.GraphExplorer;
import java.security.cert.Certificate;
import java.util.Date;
import java.util.Random;
import java.lang.invoke.MethodHandles;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TlsKeystore;
import ru.ispras.telecomtesk.tlsv13.TLSclientSpecification.*;

@jatva.lang.annotation.ScenarioClass
public 
class TestHello
    extends jatva.lang.TestingModel
{

    @jatva.lang.annotation.JTSInternal
    public TestHello() {}

    @Override
    @jatva.lang.annotation.JTSInternal
    public jatva.lang.AbstractAction _ts_initialize()
    {
        return new jatva.lang.SimpleAction( 0 /* connect */ );
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected int _ts_getMaxMethodNumber()
    { return 3; }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected jatva.lang.AbstractAction _ts_nextDeclared( int currentMethodNumber )
    {
        switch( currentMethodNumber )
        {
            case 0: return new AbstractAction_ServerHello();
            case 1: return new AbstractAction_ServerHello2();
            case 2: return new AbstractAction_ServerHello3();
            default:
                return super._ts_nextDeclared( currentMethodNumber );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected void _ts_executeDeclared( jatva.lang.AbstractAction _par_action )
    {
        switch( _par_action.method() )
        {
            case 0:
                _ts_partialExecute_connect( _par_action );
                break;
            case 1:
                _ts_partialExecute_ServerHello( _par_action );
                break;
            case 2:
                _ts_partialExecute_ServerHello2( _par_action );
                break;
            case 3:
                _ts_partialExecute_ServerHello3( _par_action );
                break;
            default:
                super._ts_executeDeclared( _par_action );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected String _ts_getScenMethodName( int method_number )
    {
        switch( method_number )
        {
            case 0:
                return "connect";
            case 1:
                return "ServerHello";
            case 2:
                return "ServerHello2";
            case 3:
                return "ServerHello3";
            default:
                return super._ts_getScenMethodName( method_number );
        }
    }

    public
    TLSClientScenProp scenParam;

    public
    String scenName;

    private
    String currentClassName;

    private
    short[] serverSupportedCipherSuites;

    private
    NamedGroup[] serverSupportedNamedGroups;


    SignatureAndHashAlgorithmExt hl_ext_sah;


    SignatureAndHashAlgorithmExt hl_ext_sah2;


    byte[] dataext = {
        1
        , 2
        , 3
        , 4
        , 5}
    ;


    TLSExtension hl_ext_un, hl_ext_un2;


    NamedGroup[] sg = {
        NamedGroup.FFDHEtest
        , NamedGroup.FFDHE2048
        , NamedGroup.SECP256R1}
    ;


    SupportedGroupsExt hl_ext_sg, hl_ext_sg2;


    NamedGroup[] sendgrp = {
        NamedGroup.SECP256R1
        , NamedGroup.FFDHE2048}
    ;


    TLSExtension hl_ext_sv, hl_ext_sv2, hl_ext_sv3;


    TLSExtension hl_ext_ks, hl_ext_ks2;


    byte[] dataId = {
        1
        , 2
        , 3
        , 4
        , 5
        , 6
        , 1
        , 2
        , 3
        , 4
        , 5
        , 6
        , 1
        , 2
        , 3
        , 4
        , 5
        , 6
        , 1
        , 2
        , 3
        , 4
        , 5
        , 6
        , 1
        , 2
        , 3
        , 4
        , 5
        , 6
        , 7
        , 8}
    ;


    SignatureScheme[] sah = {
        SignatureScheme.RSA_PKCS1_SHA256
        , SignatureScheme.ECDSA_SECP256R1_SHA256
        , SignatureScheme.RSA_PSS_RSAE_SHA256}
    ;


    ProtocolVersion svdata = new ProtocolVersion( 0x03, 0x04 );


    ProtocolVersion[] svdata2 = {
        new ProtocolVersion( 0x03, 0x04 )
        , new ProtocolVersion( 0x03, 0x03 )}
    ;

    public
    TestHello( String logFileName)
    {
        super( );
        DebugInfo.debugLevel = 4;
        currentClassName = MethodHandles.lookup(  ).lookupClass(  ).getSimpleName(  );
        scenParam = new TLSClientScenProp( logFileName, currentClassName );

        TLSConnectionSelector sel = new TLSConnectionSelector( null, null, 0, 0 );
        scenParam.current_connection = new TLSConnection( sel, ConnectionRole.SERVER );
        serverSupportedCipherSuites = new short[]{
            TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )
            , TLSCipherSuite.TLS_AES_256_GCM_SHA384.getValue(  )}
        ;
        serverSupportedNamedGroups = new NamedGroup[]{
            NamedGroup.SECP256R1
            , NamedGroup.FFDHE2048
            , NamedGroup.SECP384R1
            , NamedGroup.FFDHE3072}
        ;

        GraphExplorer xxx = new DFSMExplorer(  );
        xxx.setMaximumNumberOfTransitions( 5000 );
        xxx.setNumberOfNoncriticalErrorsToIgnore( 5000 );
        setTestEngine( xxx );
        hl_ext_sah = new SignatureAndHashAlgorithmExt( sah );
        hl_ext_sah2 = new SignatureAndHashAlgorithmExt( sah );
        hl_ext_un = new TLSExtension( 1020, dataext );
        hl_ext_un2 = new TLSExtension( 1020, dataext );
        hl_ext_sg = new SupportedGroupsExt( sg );
        hl_ext_sg2 = new SupportedGroupsExt( sg );
        hl_ext_sv = new SupportedVersionsExt( svdata );
        hl_ext_sv2 = new SupportedVersionsExt( svdata );
        hl_ext_sv3 = new SupportedVersionsExt( svdata2 );
    }

    @jatva.lang.annotation.StateBlock
    public 
    Object _ts_state()
    {
        try
        {
            return scenParam.target.getCurrentState(  );
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.GenStateCalculationException
                ( this
                , _lv_error
                );
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "connect" )
    protected void _ts_partialExecute_connect
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "connect", _par_parameter_action );
        try
        {
            {
                scenName = " Connect ";
                DebugInfo.printMessageWithSeparator( 3, "!!!scenario try," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessageWithSeparator( 3, "!already connected" );
                    return;
                }
                scenParam.connectCounter++;
                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );
                try
                {
                    scenParam.target.connect( scenParam.current_connection );
                }
                catch( jatva.lang.TestException terr )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario TestException:" + scenName + terr );
                    scenParam.target.disconnect(  );
                    throw terr;
                }
                catch( Exception err )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario failed:" + scenName + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello"
                        , "connect"
                        , "scenario failed" + scenName + err
                        );
                }
                scenParam.scenarioCounter++;
                scenName = " ServerHelloRetry ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                Exception err = null;

                TLSExtension hlr_ext_ks = null;

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;

                NamedGroup[] serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( serNmGrp == null )
                {

                    short[] cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );
                    serNmGrp = curHPrm.chooseRetryNamedGroup( serverSupportedNamedGroups );
                    if( cs == null )
                    {
                        DebugInfo.printMessage( 1, "Error!!! No suitable CipherSuites" );
                        checkFlag = true;
                    }
                    if( serNmGrp == null )
                    {
                        DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                        checkFlag = true;
                    }
                    if( scenParam.target.last_client_hello == null )
                    {
                        DebugInfo.printMessage( 1, "Error!!! last_client_hello == null" );
                        checkFlag = true;
                    }
                    if( checkFlag )
                    {
                        scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                        scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                        throw new jatva.lang.ScenarioConstraintViolationException
                            ( "TestHello"
                            , "connect"
                            );
                    }
                    hlr_ext_ks = new KeyShareHelloRetry( serNmGrp[0] );

                    byte[] dataId = {
                        1
                        , 2
                        , 3
                        , 4
                        , 5
                        , 6
                        , 1
                        , 2
                        , 3
                        , 4
                        , 5
                        , 6
                        , 1
                        , 2
                        , 3
                        , 4
                        , 5
                        , 6
                        , 1
                        , 2
                        , 3
                        , 4
                        , 5
                        , 6
                        , 1
                        , 2
                        , 3
                        , 4
                        , 5
                        , 6
                        , 7
                        , 8}
                    ;

                    CookieExt hl_ext_ck = new CookieExt( dataId );

                    HelloRetryRequest msgHRR = null;
                    msgHRR = new HelloRetryRequest( scenParam.target.last_client_hello.sessionID, cs );
                    msgHRR.addExtension( hl_ext_sv );
                    msgHRR.addExtension( hl_ext_ck );
                    msgHRR.addExtension( hlr_ext_ks );
                    DebugInfo.printMessage( 1, "send HelloRetryRequest" );
                    err = scenParam.msgSetContentAndSend( msgHRR, null, scenName );
                    if( err != null )
                    {
                        throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                    }
                }
                else
                    DebugInfo.printMessage( 1, "No need ServerHelloRetry" );

                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "connect"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    @jatva.lang.annotation.JTSInternal
    protected class AbstractAction_ServerHello
        extends jatva.lang.AbstractAction
    {
        @jatva.lang.annotation.JTSInternal
        int choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        int next_value_choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ServerHello()
        {
            super( 1, 1, 0 );
        }

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ServerHello( AbstractAction_ServerHello _par_r )
        {
            super( _par_r );
            choice_1_0 = _par_r.choice_1_0;
            next_value_choice_1_0 = _par_r.next_value_choice_1_0;
        }

        @Override
        @jatva.lang.annotation.JTSInternal
        public Object clone()
        {
            return new AbstractAction_ServerHello( this );
        }
    }

    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHello" )
    protected void _ts_partialExecute_ServerHello
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHello", _par_parameter_action );
        AbstractAction_ServerHello _lv_action = (AbstractAction_ServerHello)_par_parameter_action;
        jatva.lang.AbstractAction.IterationFlags _lv_tmp_flags =
            new jatva.lang.AbstractAction.IterationFlags( _lv_action );
        boolean _lv_tmp = false;
        jatva.lang.DummyClass.dummy( _lv_tmp );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHello1 ";
                DebugInfo.printMessageWithSeparator( 3, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLO) && (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLOResume) )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;

                NamedGroup[] serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );

                short[] cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );
                serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( scenParam.localks == null )
                {
                    DebugInfo.printMessage( 3, "Error!!! local Keystore not found" );
                    checkFlag = true;
                }
                if( serNmGrp == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello"
                        , "ServerHello"
                        );
                }
                DebugInfo.printMessage( 3, "local Keystore found" );
                TlsKeystore.getCertificate( scenParam.localks, curHPrm );
                curHPrm.generateServerKeyPair( serNmGrp[0] );
                hl_ext_ks = new KeyShareServerHello( curHPrm.serverKeyShare );

                Hello msg = null;
                msg = new Hello( scenParam.target.last_client_hello.sessionID, cs );
                msg.setTypeServerHello(  );

                RecordLayer tlsmsg = new RecordLayer(  );
                _lv_tmp_flags.setUsage( 0 );
                if( !(_lv_action.isIterationInitialized( 0 )) )
                {
                    _lv_action.choice_1_0 = 0;
                    if( _lv_action.choice_1_0 + 1 >= 14 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                else if( _lv_action.isIterationMove( 0 ) )
                {
                    _lv_action.choice_1_0++;
                    if( _lv_action.choice_1_0 + 1 >= 14 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                _lv_registrar.registerIterationVariableValue
                    ( jatva.tracer.ValueKind.CHOICE_ITERATION_VARIABLE
                    , "int"
                    , "choice_1"
                    , true
                    , _lv_action.choice_1_0
                    );
                switch( _lv_action.choice_1_0 )
                {
                    case 1:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion 2.0" );
                            msg.version.setValue( 2, 0 );
                        }

                        break;
                    case 2:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion 3.0" );
                            msg.version.setValue( 3, 0 );
                        }

                        break;
                    case 3:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion 3.2" );
                            msg.version.setValue( 3, 2 );
                        }

                        break;
                    case 4:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion 3.5" );
                            msg.version.setValue( 3, 5 );
                        }

                        break;
                    case 5:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion 4.2" );
                            msg.version.setValue( 4, 2 );
                        }

                        break;
                    case 6:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion f.f" );
                            msg.version.setValue( 0xff, 0xff );
                        }

                        break;
                    case 7:
                        {
                            DebugInfo.printMessage( 1, "empty session ID" );
                            msg.sessionID = new byte[0];
                        }

                        break;
                    case 8:
                        {
                            DebugInfo.printMessage( 1, "Random session ID 32 bytes" );

                            byte[] rndID = new byte[32];

                            Random rndObj = new Random( System.currentTimeMillis(  ) );
                            rndObj.nextBytes( rndID );
                            msg.sessionID = rndID;
                        }

                        break;
                    case 9:
                        {
                            DebugInfo.printMessage( 1, "Random session ID 20 bytes" );

                            byte[] rndID = new byte[20];

                            Random rndObj = new Random( System.currentTimeMillis(  ) );
                            rndObj.nextBytes( rndID );
                            msg.sessionID = rndID;
                        }

                        break;
                    case 10:
                        {
                            DebugInfo.printMessage( 1, "CipherSuite differ from in HelloRetry" );
                            msg.cipher_suites = new short[]{
                                serverSupportedCipherSuites[1]}
                            ;
                        }

                        break;
                    case 11:
                        {
                            DebugInfo.printMessage( 1, "compression_methods 5" );
                            msg.compression_methods[0] = 5;
                        }

                        break;
                    case 12:
                        {
                            DebugInfo.printMessage( 1, "compression_methods two bytes" );
                            msg.compression_methods = new byte[2];
                            msg.compression_methods[0] = 3;
                            msg.compression_methods[1] = 2;
                        }

                        break;
                    case 13:
                        {
                            DebugInfo.printMessage( 1, "CipherSuite is TLS_NULL_WITH_NULL_NULL" );

                            short[] cs1 = {
                                TLSCipherSuite.TLS_NULL_WITH_NULL_NULL.getValue(  )}
                            ;
                            msg.cipher_suites = cs1;
                        }

                        break;
                    default:
                        {
                            DebugInfo.printMessage( 1, "ProtocolVersion 0.0" );
                            msg.version.setValue( 0, 0 );
                        }

                        break;
                }
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_ks );
                DebugInfo.printMessage( 1, "print Hello" );
                msg.print(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenParam.target.disconnectWithSendAlert = 0;
                scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHello"
                , _lv_error
                );
        }
        finally
        {
            _lv_action.retrieveFlags( _lv_tmp_flags );
            _lv_registrar.scenarioMethodExit();
        }
    }

    @jatva.lang.annotation.JTSInternal
    protected class AbstractAction_ServerHello2
        extends jatva.lang.AbstractAction
    {
        @jatva.lang.annotation.JTSInternal
        int choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        int next_value_choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ServerHello2()
        {
            super( 2, 1, 0 );
        }

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ServerHello2( AbstractAction_ServerHello2 _par_r )
        {
            super( _par_r );
            choice_1_0 = _par_r.choice_1_0;
            next_value_choice_1_0 = _par_r.next_value_choice_1_0;
        }

        @Override
        @jatva.lang.annotation.JTSInternal
        public Object clone()
        {
            return new AbstractAction_ServerHello2( this );
        }
    }

    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHello2" )
    protected void _ts_partialExecute_ServerHello2
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHello2", _par_parameter_action );
        AbstractAction_ServerHello2 _lv_action = (AbstractAction_ServerHello2)_par_parameter_action;
        jatva.lang.AbstractAction.IterationFlags _lv_tmp_flags =
            new jatva.lang.AbstractAction.IterationFlags( _lv_action );
        boolean _lv_tmp = false;
        jatva.lang.DummyClass.dummy( _lv_tmp );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHello2 ";
                DebugInfo.printMessageWithSeparator( 3, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLO) && (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLOResume) )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;

                NamedGroup[] serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );

                short[] cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );
                serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( scenParam.localks == null )
                {
                    DebugInfo.printMessage( 3, "Error!!! local Keystore not found" );
                    checkFlag = true;
                }
                if( serNmGrp == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello"
                        , "ServerHello2"
                        );
                }
                DebugInfo.printMessage( 3, "local Keystore found" );
                TlsKeystore.getCertificate( scenParam.localks, curHPrm );
                curHPrm.generateServerKeyPair( serNmGrp[0] );
                hl_ext_ks = new KeyShareServerHello( curHPrm.serverKeyShare );
                hl_ext_ks2 = new KeyShareServerHello( curHPrm.serverKeyShare );

                Hello msg = null;
                msg = new Hello( scenParam.target.last_client_hello.sessionID, cs );
                msg.setTypeServerHello(  );

                RecordLayer tlsmsg = new RecordLayer(  );
                _lv_tmp_flags.setUsage( 0 );
                if( !(_lv_action.isIterationInitialized( 0 )) )
                {
                    _lv_action.choice_1_0 = 0;
                    if( _lv_action.choice_1_0 + 1 >= 13 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                else if( _lv_action.isIterationMove( 0 ) )
                {
                    _lv_action.choice_1_0++;
                    if( _lv_action.choice_1_0 + 1 >= 13 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                _lv_registrar.registerIterationVariableValue
                    ( jatva.tracer.ValueKind.CHOICE_ITERATION_VARIABLE
                    , "int"
                    , "choice_1"
                    , true
                    , _lv_action.choice_1_0
                    );
                switch( _lv_action.choice_1_0 )
                {
                    case 1:
                        {
                            DebugInfo.printMessage( 1, "extentions list: SupportedVersions only" );
                            msg.addExtension( hl_ext_sv );
                        }

                        break;
                    case 2:
                        {
                            DebugInfo.printMessage( 1, "Bad SupportedVersions extention" );
                            msg.addExtension( hl_ext_sv3 );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 3:
                        {
                            DebugInfo.printMessage( 1, "Unknown extention" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_un );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 4:
                        {
                            DebugInfo.printMessage( 3, "===Warning! add Cookie TLSExtension" );

                            byte[] dataId = {
                                1
                                , 2
                                , 3
                                , 4
                                , 5
                                , 6
                                , 1
                                , 2
                                , 3
                                , 4
                                , 5
                                , 6
                                , 1
                                , 2
                                , 3
                                , 4
                                , 5
                                , 6
                                , 1
                                , 2
                                , 3
                                , 4
                                , 5
                                , 6
                                , 1
                                , 2
                                , 3
                                , 4
                                , 5
                                , 6
                                , 7
                                , 8}
                            ;

                            CookieExt hl_ext_ck = new CookieExt( dataId );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_ck );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 5:
                        {
                            DebugInfo.printMessage( 3, "===Warning! add SignatureAlgorithmCert TLSExtension with illegal params" );

                            SignatureScheme[] sah_cr = {
                                SignatureScheme.PRIVATE_USE
                                , SignatureScheme.UNKNOWN}
                            ;

                            SignatureAlgorithmCertExt hl_ext_sah_cr = new SignatureAlgorithmCertExt( sah_cr );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_sah_cr );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 6:
                        {
                            DebugInfo.printMessage( 3, "===Warning! add SignatureAlgorithmCert2 TLSExtension with illegal params" );

                            SignatureScheme[] sah = {
                                SignatureScheme.RSA_PKCS1_SHA256
                                , SignatureScheme.ECDSA_SECP256R1_SHA256}
                            ;

                            SignatureScheme[] sah_cr = {
                                SignatureScheme.PRIVATE_USE
                                , SignatureScheme.UNKNOWN}
                            ;

                            SignatureAndHashAlgorithmExt hl_ext_sah = new SignatureAndHashAlgorithmExt( sah );

                            SignatureAlgorithmCertExt hl_ext_sah_cr = new SignatureAlgorithmCertExt( sah_cr );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_sah );
                            msg.addExtension( hl_ext_sah_cr );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 7:
                        {
                            DebugInfo.printMessage( 1, "SupportedGroups extention" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_sg );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 8:
                        {
                            DebugInfo.printMessage( 1, "dublicate Unknown extention" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_un );
                            msg.addExtension( hl_ext_un2 );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 9:
                        {
                            DebugInfo.printMessage( 1, "dublicate extention 1" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_sv2 );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                    case 10:
                        {
                            DebugInfo.printMessage( 1, "dublicate extention 2" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_ks );
                            msg.addExtension( hl_ext_ks2 );
                        }

                        break;
                    case 11:
                        {
                            DebugInfo.printMessage( 1, "extention length wrong 1" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_ks );
                            msg.addExtension( hl_ext_sg2 );
                            msg.setLength(  );
                            msg.setLength( msg.getLength(  ) - hl_ext_sg2.getSize(  ) );
                            scenParam.target.waitFatalAlert = 50;
                        }

                        break;
                    case 12:
                        {
                            DebugInfo.printMessage( 1, "extention length wrong 2" );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_ks );
                            msg.addExtension( hl_ext_un );
                            msg.setLength(  );
                            msg.removeExtension( hl_ext_un );
                            msg.toByteArray(  );

                            byte[] tmpext = hl_ext_un.toByteArray(  );

                            byte[] newmsg = new byte[msg.net_msg.length + tmpext.length];
                            System.arraycopy( msg.net_msg, 0, newmsg, 0, msg.net_msg.length );
                            System.arraycopy( tmpext, 0, newmsg, msg.net_msg.length, tmpext.length );
                            msg.net_msg = newmsg;
                            scenParam.target.waitFatalAlert = 50;
                        }

                        break;
                    default:
                        {
                            DebugInfo.printMessage( 1, "KeyShare not exist in ClientHello" );
                            curHPrm.generateServerKeyPair( serverSupportedNamedGroups[1] );
                            hl_ext_ks = new KeyShareServerHello( curHPrm.serverKeyShare );
                            msg.addExtension( hl_ext_sv );
                            msg.addExtension( hl_ext_ks );
                        }

                        break;
                }
                DebugInfo.printMessage( 1, "print Hello" );
                msg.print(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenParam.target.disconnectWithSendAlert = 0;
                scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHello2"
                , _lv_error
                );
        }
        finally
        {
            _lv_action.retrieveFlags( _lv_tmp_flags );
            _lv_registrar.scenarioMethodExit();
        }
    }

    @jatva.lang.annotation.JTSInternal
    protected class AbstractAction_ServerHello3
        extends jatva.lang.AbstractAction
    {
        @jatva.lang.annotation.JTSInternal
        int choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        int next_value_choice_1_0 = 0;

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ServerHello3()
        {
            super( 3, 1, 0 );
        }

        @jatva.lang.annotation.JTSInternal
        public AbstractAction_ServerHello3( AbstractAction_ServerHello3 _par_r )
        {
            super( _par_r );
            choice_1_0 = _par_r.choice_1_0;
            next_value_choice_1_0 = _par_r.next_value_choice_1_0;
        }

        @Override
        @jatva.lang.annotation.JTSInternal
        public Object clone()
        {
            return new AbstractAction_ServerHello3( this );
        }
    }

    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHello3" )
    protected void _ts_partialExecute_ServerHello3
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHello3", _par_parameter_action );
        AbstractAction_ServerHello3 _lv_action = (AbstractAction_ServerHello3)_par_parameter_action;
        jatva.lang.AbstractAction.IterationFlags _lv_tmp_flags =
            new jatva.lang.AbstractAction.IterationFlags( _lv_action );
        boolean _lv_tmp = false;
        jatva.lang.DummyClass.dummy( _lv_tmp );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHello3 ";
                DebugInfo.printMessageWithSeparator( 3, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLO) && (scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_ClientHELLOResume) )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;

                NamedGroup[] serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );

                short[] cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );
                serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( scenParam.localks == null )
                {
                    DebugInfo.printMessage( 3, "Error!!! local Keystore not found" );
                    checkFlag = true;
                }
                if( serNmGrp == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello"
                        , "ServerHello3"
                        );
                }
                DebugInfo.printMessage( 3, "local Keystore found" );
                TlsKeystore.getCertificate( scenParam.localks, curHPrm );
                curHPrm.generateServerKeyPair( serNmGrp[0] );
                hl_ext_ks = new KeyShareServerHello( curHPrm.serverKeyShare );

                Hello msg = null;
                msg = new Hello( scenParam.target.last_client_hello.sessionID, cs );
                msg.setTypeServerHello(  );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_ks );
                DebugInfo.printMessage( 1, "print Hello" );
                msg.print(  );

                RecordLayer tlsmsg = new RecordLayer( msg );
                scenParam.msgSetTestContent( tlsmsg, null, msg, scenName );
                _lv_tmp_flags.setUsage( 0 );
                if( !(_lv_action.isIterationInitialized( 0 )) )
                {
                    _lv_action.choice_1_0 = 0;
                    if( _lv_action.choice_1_0 + 1 >= 4 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                else if( _lv_action.isIterationMove( 0 ) )
                {
                    _lv_action.choice_1_0++;
                    if( _lv_action.choice_1_0 + 1 >= 4 )
                        _lv_tmp_flags.setLast( 0, true );
                    else
                    {
                        _lv_tmp_flags.setLast( 0, false );
                        _lv_action.next_value_choice_1_0 = _lv_action.choice_1_0 + 1;
                    }
                }
                _lv_registrar.registerIterationVariableValue
                    ( jatva.tracer.ValueKind.CHOICE_ITERATION_VARIABLE
                    , "int"
                    , "choice_1"
                    , true
                    , _lv_action.choice_1_0
                    );
                switch( _lv_action.choice_1_0 )
                {
                    case 1:
                        {
                            DebugInfo.printMessage( 1, "RecordLayer ProtocolVersion 3.2" );
                            tlsmsg.version.setValue( 3, 2 );
                        }

                        break;
                    case 2:
                        {
                            DebugInfo.printMessage( 1, "RecordLayer ProtocolVersion 3.11" );
                            tlsmsg.version.setValue( 3, 11 );
                        }

                        break;
                    case 3:
                        {
                            DebugInfo.printMessage( 1, "RecordLayer length wrong 1" );
                            tlsmsg.setLength(  );
                            tlsmsg.setLength( tlsmsg.getLength(  ) - hl_ext_ks.getSize(  ) );
                        }

                        break;
                    default:
                        {
                            DebugInfo.printMessage( 1, "RecordLayer ProtocolVersion 3.0" );
                            tlsmsg.version.setValue( 3, 0 );
                        }

                        break;
                }

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenParam.target.disconnectWithSendAlert = 0;
                scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHello3"
                , _lv_error
                );
        }
        finally
        {
            _lv_action.retrieveFlags( _lv_tmp_flags );
            _lv_registrar.scenarioMethodExit();
        }
    }

    public
    void finalize( )
    {
        try
        {
            DebugInfo.printMessage( 1, "===finalize===" );
            scenParam.target.stop(  );
        }
        catch( Exception err )
        {
            DebugInfo.printMessage( 1, "===Error! StopServer: " + err );
        }
    }


    public static
    void main( String[] args)
    {

        String fileName = "connectInfo_java.txt";
        if( args.length > 0 )
            fileName = args[0];

        start( fileName );
    }


    public static
    void start( String fileName)
    {

        TestHello scen = new TestHello( fileName );

        Date dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "start test " + scen.currentClassName + " " + dt1.toString(  ) );
        scen.run(  );
        scen.finalize(  );
        dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "end test: " + dt1.toString(  ) + " testCounter " + scen.scenParam.connectCounter + " scenarioCounter " + scen.scenParam.scenarioCounter );
        scen.scenParam.logFile.close(  );
    }

}
