package ru.ispras.telecomtesk.tlsv13.TestsClient.MainTests;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import jatva.lang.GraphExplorer;
import java.security.cert.Certificate;
import java.util.Date;
import java.util.Random;
import java.lang.invoke.MethodHandles;
import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TlsKeystore;
import ru.ispras.telecomtesk.tlsv13.TLSclientSpecification.*;

@jatva.lang.annotation.ScenarioClass
public 
class TestHello2
    extends jatva.lang.TestingModel
{

    @jatva.lang.annotation.JTSInternal
    public TestHello2() {}

    @Override
    @jatva.lang.annotation.JTSInternal
    public jatva.lang.AbstractAction _ts_initialize()
    {
        return new jatva.lang.SimpleAction( 0 /* Handshake_pre */ );
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected int _ts_getMaxMethodNumber()
    { return 2; }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected jatva.lang.AbstractAction _ts_nextDeclared( int currentMethodNumber )
    {
        switch( currentMethodNumber )
        {
            case 0: return new jatva.lang.SimpleAction( 1 /* Certificate */ );
            case 1: return new jatva.lang.SimpleAction( 2 /* Handshake_post */ );
            default:
                return super._ts_nextDeclared( currentMethodNumber );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected void _ts_executeDeclared( jatva.lang.AbstractAction _par_action )
    {
        switch( _par_action.method() )
        {
            case 0:
                _ts_partialExecute_Handshake_pre( _par_action );
                break;
            case 1:
                _ts_partialExecute_Certificate( _par_action );
                break;
            case 2:
                _ts_partialExecute_Handshake_post( _par_action );
                break;
            default:
                super._ts_executeDeclared( _par_action );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected String _ts_getScenMethodName( int method_number )
    {
        switch( method_number )
        {
            case 0:
                return "Handshake_pre";
            case 1:
                return "Certificate";
            case 2:
                return "Handshake_post";
            default:
                return super._ts_getScenMethodName( method_number );
        }
    }

    public
    TLSClientScenProp scenParam;

    public
    String scenName;

    private
    String currentClassName;

    private
    short[] serverSupportedCipherSuites;

    private
    NamedGroup[] serverSupportedNamedGroups;

    public
    TestHello2( String logFileName)
    {
        super( );
        DebugInfo.debugLevel = 4;
        currentClassName = MethodHandles.lookup(  ).lookupClass(  ).getSimpleName(  );
        scenParam = new TLSClientScenProp( logFileName, currentClassName );

        TLSConnectionSelector sel = new TLSConnectionSelector( null, null, 0, 0 );
        scenParam.current_connection = new TLSConnection( sel, ConnectionRole.SERVER );
        serverSupportedCipherSuites = new short[]{
            TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )
            , TLSCipherSuite.TLS_AES_256_GCM_SHA384.getValue(  )}
        ;
        serverSupportedNamedGroups = new NamedGroup[]{
            NamedGroup.SECP256R1
            , NamedGroup.FFDHE2048
            , NamedGroup.SECP384R1
            , NamedGroup.FFDHE3072}
        ;

        GraphExplorer xxx = new DFSMExplorer(  );
        xxx.setMaximumNumberOfTransitions( 5000 );
        xxx.setNumberOfNoncriticalErrorsToIgnore( 5000 );
        setTestEngine( xxx );
    }

    @jatva.lang.annotation.StateBlock
    public 
    Object _ts_state()
    {
        try
        {
            return scenParam.target.getCurrentState(  );
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.GenStateCalculationException
                ( this
                , _lv_error
                );
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Handshake_pre" )
    protected void _ts_partialExecute_Handshake_pre
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Handshake_pre", _par_parameter_action );
        try
        {
            {
                scenName = " Connect ";
                DebugInfo.printMessageWithSeparator( 4, "!!!scenario try," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessageWithSeparator( 4, "!already connected" );
                    return;
                }
                scenParam.connectCounter++;
                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );
                try
                {
                    scenParam.target.connect( scenParam.current_connection );
                }
                catch( jatva.lang.TestException terr )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario TestException:" + scenName + terr );
                    scenParam.target.disconnect(  );
                    throw terr;
                }
                catch( Exception err )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario failed:" + scenName + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello2"
                        , "Handshake_pre"
                        , "scenario failed" + scenName + err
                        );
                }
                scenParam.scenarioCounter++;
                scenName = " ServerHelloRetry ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                Exception err = null;

                short[] cs = null;

                TLSExtension hl_ext_ks = null;

                TLSExtension hl_ext_sv = new SupportedVersionsExt( new ProtocolVersion( 0x03, 0x04 ) );

                TLSHandshakeParameters curHPrm = scenParam.current_connection.getHandshakeParams(  );

                boolean checkFlag = false;
                cs = curHPrm.chooseCipherSuite( serverSupportedCipherSuites );

                NamedGroup[] serNmGrp = new NamedGroup[]{
                    NamedGroup.FFDHE2048}
                ;
                if( cs == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable CipherSuites" );
                    checkFlag = true;
                }
                if( scenParam.target.last_client_hello == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! last_client_hello == null" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello2"
                        , "Handshake_pre"
                        );
                }
                hl_ext_ks = new KeyShareHelloRetry( serNmGrp[0] );

                byte[] dataId = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8}
                ;

                CookieExt hl_ext_ck = new CookieExt( dataId );

                HelloRetryRequest msgHRR = null;
                msgHRR = new HelloRetryRequest( scenParam.target.last_client_hello.sessionID, cs );
                msgHRR.addExtension( hl_ext_sv );
                msgHRR.addExtension( hl_ext_ck );
                msgHRR.addExtension( hl_ext_ks );
                DebugInfo.printMessage( 1, "send HelloRetryRequest" );
                err = scenParam.msgSetContentAndSend( msgHRR, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                scenParam.scenarioCounter++;
                scenName = " ServerHello ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessage( 1, "not connected" );
                    return;
                }
                DebugInfo.printMessage( 1, "scenario start," + scenName );
                checkFlag = false;
                cs = new short[]{
                    TLSCipherSuite.TLS_AES_256_GCM_SHA384.getValue(  )}
                ;
                serNmGrp = curHPrm.chooseKeyShare( serverSupportedNamedGroups );
                if( scenParam.localks == null )
                {
                    DebugInfo.printMessage( 3, "Error!!! local Keystore not found" );
                    checkFlag = true;
                }
                if( cs == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable CipherSuites" );
                    checkFlag = true;
                }
                if( serNmGrp == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! No suitable NamedGroup" );
                    checkFlag = true;
                }
                if( scenParam.target.last_client_hello == null )
                {
                    DebugInfo.printMessage( 1, "Error!!! last_client_hello == null" );
                    checkFlag = true;
                }
                if( checkFlag )
                {
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello2"
                        , "Handshake_pre"
                        );
                }
                DebugInfo.printMessage( 3, "local Keystore found" );
                TlsKeystore.getCertificate( scenParam.localks, curHPrm );
                curHPrm.generateServerKeyPair( serNmGrp[0] );
                hl_ext_ks = new KeyShareServerHello( curHPrm.serverKeyShare );

                Hello msgSH = null;
                msgSH = new Hello( scenParam.target.last_client_hello.sessionID, cs );
                msgSH.setTypeServerHello(  );
                msgSH.addExtension( hl_ext_sv );
                msgSH.addExtension( hl_ext_ks );
                DebugInfo.printMessage( 1, "print ServerHello" );
                msgSH.print(  );
                err = scenParam.msgSetContentAndSend( msgSH, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                scenParam.scenarioCounter++;
                scenName = " EncryptedExtensions ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                NamedGroup[] sg = {
                    NamedGroup.FFDHEtest
                    , NamedGroup.FFDHE2048
                    , NamedGroup.SECP256R1}
                ;

                SupportedGroupsExt hl_ext_sg = new SupportedGroupsExt( sg );

                EncryptedExtensions msgEE = new EncryptedExtensions(  );
                msgEE.addExtension( hl_ext_sg );
                err = scenParam.msgSetContentAndSend( msgEE, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Handshake_pre"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Certificate" )
    protected void _ts_partialExecute_Certificate
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Certificate", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Certificate ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ) != TLSScenarioState.AFTER_EncryptedExtensions )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                HMCertificate msgCR = new HMCertificate(  );

                Certificate lcert = scenParam.current_connection.getHandshakeParams(  ).localCert;

                CertificateEntry curCrt = null;
                if( lcert != null )
                {
                    DebugInfo.printMessage( 3, "local certificate found" );

                    byte[][] chain = TlsKeystore.getCertificateChainEncoded( scenParam.localks, lcert );
                    if( chain != null )
                        for( 
                        int i = 0; i < chain.length; i++)
                        msgCR.addCertificate( new CertificateEntry( chain[i] ) );

                    else
                    {
                        DebugInfo.printMessage( 3, "Warning!!! Local certificate not found" );
                        scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                        scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                        throw new jatva.lang.ScenarioConstraintViolationException
                            ( "TestHello2"
                            , "Certificate"
                            );
                    }
                }
                else
                {
                    DebugInfo.printMessage( 3, "Warning!!! Local certificate not found" );
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello2"
                        , "Certificate"
                        );
                }
                curCrt = msgCR.getFirstCertificate(  );

                Exception err = null;

                RecordLayer rmsg = null;

                byte[] msgArray = null;

                boolean isContentSet = false;
                err = scenParam.msgSetContentAndSend( msgCR, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Certificate"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Handshake_post" )
    protected void _ts_partialExecute_Handshake_post
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Handshake_post", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " CertificateVerify ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                CertificateVerify msgCV = new CertificateVerify( scenParam.current_connection, scenParam.localks, scenParam.localKeystorePwd );
                if( (msgCV.alg == null) || (msgCV.getSignature(  ) == null) )
                {
                    DebugInfo.printMessageWithSeparator( 1, "Error!!! signature" );
                    scenParam.target.disconnectWithSendAlert = AlertType.HANDSHAKE_FAILURE.getValue(  );
                    scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello2"
                        , "Handshake_post"
                        );
                }

                Exception err = null;
                err = scenParam.msgSetContentAndSend( msgCV, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                scenParam.scenarioCounter++;
                scenName = " Finished ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessageWithSeparator( 1, "scenario start," + scenName );

                Finished msgF = null;
                try
                {
                    msgF = new Finished( scenParam.current_connection, MessageDirection.getMessageDirection( scenParam.current_connection.localRole, TLSDirection.SEND ) );
                }
                catch( Exception err1 )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err1 );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TestHello2"
                        , "Handshake_post"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }
                err = scenParam.msgSetContentAndSend( msgF, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenName = " Application ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.isHandshakeComplete(  ) )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ApplicationData msg3 = new ApplicationData( scenParam.applicationDataString.getBytes(  ) );
                err = scenParam.msgSetContentAndSend( msg3, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": msgSetContentAndSend failed ", err );
                }
                scenParam.target.disconnectWithSendAlert = 0;
                scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Handshake_post"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    public
    void finalize( )
    {
        try
        {
            DebugInfo.printMessage( 1, "===finalize===" );
            scenParam.target.stop(  );
        }
        catch( Exception err )
        {
            DebugInfo.printMessage( 1, "===Error! StopServer: " + err );
        }
    }


    public static
    void main( String[] args)
    {

        String fileName = "connectInfo_java.txt";
        if( args.length > 0 )
            fileName = args[0];

        start( fileName );
    }


    public static
    void start( String fileName)
    {

        TestHello2 scen = new TestHello2( fileName );

        Date dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "start test " + scen.currentClassName + " " + dt1.toString(  ) );
        scen.run(  );
        scen.finalize(  );
        dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "end test: " + dt1.toString(  ) + " testCounter " + scen.scenParam.connectCounter + " scenarioCounter " + scen.scenParam.scenarioCounter );
        scen.scenParam.logFile.close(  );
    }

}
