package ru.ispras.telecomtesk.tlsv13.TestsServer;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import jatva.lang.GraphExplorer;
import java.util.Date;
import java.util.Random;
import java.lang.invoke.MethodHandles;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSserverSpecification.*;

@jatva.lang.annotation.ScenarioClass
public 
class TLSBasicTest
    extends jatva.lang.TestingModel
{

    @jatva.lang.annotation.JTSInternal
    public TLSBasicTest() {}

    @Override
    @jatva.lang.annotation.JTSInternal
    public jatva.lang.AbstractAction _ts_initialize()
    {
        return new jatva.lang.SimpleAction( 0 /* connect */ );
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected int _ts_getMaxMethodNumber()
    { return 26; }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected jatva.lang.AbstractAction _ts_nextDeclared( int currentMethodNumber )
    {
        switch( currentMethodNumber )
        {
            case 0: return new jatva.lang.SimpleAction( 1 /* ClientHello2 */ );
            case 1: return new jatva.lang.SimpleAction( 2 /* ServerHello */ );
            case 2: return new jatva.lang.SimpleAction( 3 /* ServerHelloRetry */ );
            case 3: return new jatva.lang.SimpleAction( 4 /* HelloRequest */ );
            case 4: return new jatva.lang.SimpleAction( 5 /* ServerHelloDone */ );
            case 5: return new jatva.lang.SimpleAction( 6 /* CertificateRequest */ );
            case 6: return new jatva.lang.SimpleAction( 7 /* Certificate */ );
            case 7: return new jatva.lang.SimpleAction( 8 /* CertificateVerify */ );
            case 8: return new jatva.lang.SimpleAction( 9 /* ClientKeyExchange */ );
            case 9: return new jatva.lang.SimpleAction( 10 /* ServerKeyExchange */ );
            case 10: return new jatva.lang.SimpleAction( 11 /* NewSessionTicket */ );
            case 11: return new jatva.lang.SimpleAction( 12 /* EndOfEarlyData */ );
            case 12: return new jatva.lang.SimpleAction( 13 /* EncryptedExtensions */ );
            case 13: return new jatva.lang.SimpleAction( 14 /* KeyUpdate */ );
            case 14: return new jatva.lang.SimpleAction( 15 /* Finished */ );
            case 15: return new jatva.lang.SimpleAction( 16 /* ChangeCipherPlain */ );
            case 16: return new jatva.lang.SimpleAction( 17 /* ChangeCipherCrypto */ );
            case 17: return new jatva.lang.SimpleAction( 18 /* AlertPlain */ );
            case 18: return new jatva.lang.SimpleAction( 19 /* AlertCrypto */ );
            case 19: return new jatva.lang.SimpleAction( 20 /* Application */ );
            case 20: return new jatva.lang.SimpleAction( 21 /* HandshakeUndefinedTypeMessage */ );
            case 21: return new jatva.lang.SimpleAction( 22 /* HandshakeUndefinedTypeMessage2 */ );
            case 22: return new jatva.lang.SimpleAction( 23 /* MessageHash */ );
            case 23: return new jatva.lang.SimpleAction( 24 /* RecordLayerUndefinedTypeMessage */ );
            case 24: return new jatva.lang.SimpleAction( 25 /* EmptyDataAlert */ );
            case 25: return new jatva.lang.SimpleAction( 26 /* EmptyDataHandshake */ );
            default:
                return super._ts_nextDeclared( currentMethodNumber );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected void _ts_executeDeclared( jatva.lang.AbstractAction _par_action )
    {
        switch( _par_action.method() )
        {
            case 0:
                _ts_partialExecute_connect( _par_action );
                break;
            case 1:
                _ts_partialExecute_ClientHello2( _par_action );
                break;
            case 2:
                _ts_partialExecute_ServerHello( _par_action );
                break;
            case 3:
                _ts_partialExecute_ServerHelloRetry( _par_action );
                break;
            case 4:
                _ts_partialExecute_HelloRequest( _par_action );
                break;
            case 5:
                _ts_partialExecute_ServerHelloDone( _par_action );
                break;
            case 6:
                _ts_partialExecute_CertificateRequest( _par_action );
                break;
            case 7:
                _ts_partialExecute_Certificate( _par_action );
                break;
            case 8:
                _ts_partialExecute_CertificateVerify( _par_action );
                break;
            case 9:
                _ts_partialExecute_ClientKeyExchange( _par_action );
                break;
            case 10:
                _ts_partialExecute_ServerKeyExchange( _par_action );
                break;
            case 11:
                _ts_partialExecute_NewSessionTicket( _par_action );
                break;
            case 12:
                _ts_partialExecute_EndOfEarlyData( _par_action );
                break;
            case 13:
                _ts_partialExecute_EncryptedExtensions( _par_action );
                break;
            case 14:
                _ts_partialExecute_KeyUpdate( _par_action );
                break;
            case 15:
                _ts_partialExecute_Finished( _par_action );
                break;
            case 16:
                _ts_partialExecute_ChangeCipherPlain( _par_action );
                break;
            case 17:
                _ts_partialExecute_ChangeCipherCrypto( _par_action );
                break;
            case 18:
                _ts_partialExecute_AlertPlain( _par_action );
                break;
            case 19:
                _ts_partialExecute_AlertCrypto( _par_action );
                break;
            case 20:
                _ts_partialExecute_Application( _par_action );
                break;
            case 21:
                _ts_partialExecute_HandshakeUndefinedTypeMessage( _par_action );
                break;
            case 22:
                _ts_partialExecute_HandshakeUndefinedTypeMessage2( _par_action );
                break;
            case 23:
                _ts_partialExecute_MessageHash( _par_action );
                break;
            case 24:
                _ts_partialExecute_RecordLayerUndefinedTypeMessage( _par_action );
                break;
            case 25:
                _ts_partialExecute_EmptyDataAlert( _par_action );
                break;
            case 26:
                _ts_partialExecute_EmptyDataHandshake( _par_action );
                break;
            default:
                super._ts_executeDeclared( _par_action );
        }
    }

    @Override
    @jatva.lang.annotation.JTSInternal
    protected String _ts_getScenMethodName( int method_number )
    {
        switch( method_number )
        {
            case 0:
                return "connect";
            case 1:
                return "ClientHello2";
            case 2:
                return "ServerHello";
            case 3:
                return "ServerHelloRetry";
            case 4:
                return "HelloRequest";
            case 5:
                return "ServerHelloDone";
            case 6:
                return "CertificateRequest";
            case 7:
                return "Certificate";
            case 8:
                return "CertificateVerify";
            case 9:
                return "ClientKeyExchange";
            case 10:
                return "ServerKeyExchange";
            case 11:
                return "NewSessionTicket";
            case 12:
                return "EndOfEarlyData";
            case 13:
                return "EncryptedExtensions";
            case 14:
                return "KeyUpdate";
            case 15:
                return "Finished";
            case 16:
                return "ChangeCipherPlain";
            case 17:
                return "ChangeCipherCrypto";
            case 18:
                return "AlertPlain";
            case 19:
                return "AlertCrypto";
            case 20:
                return "Application";
            case 21:
                return "HandshakeUndefinedTypeMessage";
            case 22:
                return "HandshakeUndefinedTypeMessage2";
            case 23:
                return "MessageHash";
            case 24:
                return "RecordLayerUndefinedTypeMessage";
            case 25:
                return "EmptyDataAlert";
            case 26:
                return "EmptyDataHandshake";
            default:
                return super._ts_getScenMethodName( method_number );
        }
    }

    public
    TLSServerScenProp scenParam;

    public
    String scenName;

    private
    String currentClassName;

    public
    TLSBasicTest( String logFileName)
    {
        super( );
        DebugInfo.debugLevel = 4;
        DebugInfo.maxDumpSize = 400;
        currentClassName = MethodHandles.lookup(  ).lookupClass(  ).getSimpleName(  );
        scenParam = new TLSServerScenProp( logFileName, currentClassName );

        TLSConnectionSelector sel = new TLSConnectionSelector( null, null, 0, 0 );
        scenParam.current_connection = new TLSConnection( sel, ConnectionRole.CLIENT );

        GraphExplorer xxx = new DFSMExplorer(  );
        xxx.setMaximumNumberOfTransitions( 5000 );
        xxx.setNumberOfNoncriticalErrorsToIgnore( 5000 );
        setTestEngine( xxx );
    }

    @jatva.lang.annotation.StateBlock
    public 
    Object _ts_state()
    {
        try
        {
            return scenParam.target.getCurrentState(  );
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.GenStateCalculationException
                ( this
                , _lv_error
                );
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "connect" )
    protected void _ts_partialExecute_connect
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "connect", _par_parameter_action );
        try
        {
            {
                scenName = " Connect ";
                DebugInfo.printMessageWithSeparator( 4, "!!!scenario try," + scenName + scenParam.target.currentState );
                if( scenParam.target.getCurrentState(  ).connected )
                {
                    DebugInfo.printMessageWithSeparator( 4, "!already connected" );
                    return;
                }
                scenParam.connectCounter++;
                DebugInfo.printMessage( 1, "scenario start," + scenName );
                try
                {
                    scenParam.target.connect( scenParam.current_connection );
                }
                catch( jatva.lang.TestException terr )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario TestException:" + scenName + terr );
                    scenParam.target.disconnect(  );
                    throw terr;
                }
                catch( IOException err )
                {
                    DebugInfo.logtrace( scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName );
                    DebugInfo.logtrace( scenParam.logFile, "===Error! scenario failed:" + scenName + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TLSBasicTest"
                        , "connect"
                        , "scenario failed" + scenName + err
                        );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "connect"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ClientHello2" )
    protected void _ts_partialExecute_ClientHello2
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ClientHello2", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ClientHello2 ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                short[] cs = {
                    TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )
                    , TLSCipherSuite.TLS_RSA_WITH_AES_128_CBC_SHA.getValue(  )
                    , TLSCipherSuite.TLS_RSA_WITH_AES_256_CBC_SHA256.getValue(  )}
                ;

                SignatureScheme[] sah = {
                    SignatureScheme.RSA_PKCS1_SHA256
                    , SignatureScheme.ECDSA_SECP256R1_SHA256
                    , SignatureScheme.RSA_PSS_RSAE_SHA256}
                ;

                SignatureAndHashAlgorithmExt hl_ext_sah = new SignatureAndHashAlgorithmExt( sah );

                NamedGroup[] sg = {
                    NamedGroup.FFDHEtest
                    , NamedGroup.FFDHE2048
                    , NamedGroup.SECP256R1}
                ;

                SupportedGroupsExt hl_ext_sg = new SupportedGroupsExt( sg );

                NamedGroup[] sendgrp = {
                    NamedGroup.SECP256R1}
                ;
                scenParam.current_connection.hskParams.generateClientKeyPairList( sendgrp );

                ProtocolVersion[] svdata = {
                    new ProtocolVersion( 0x03, 0x04 )
                    , new ProtocolVersion( 0x03, 0x03 )}
                ;

                TLSExtension hl_ext_sv = new SupportedVersionsExt( svdata );

                TLSExtension hl_ext_ks = new KeyShareClientHello( scenParam.current_connection.hskParams.clientKeyShareList );

                byte[] dataId = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8}
                ;

                Hello msg = new Hello( dataId, cs );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_sah );
                msg.addExtension( hl_ext_sg );
                msg.addExtension( hl_ext_ks );
                if( scenParam.target.needCookie )
                {

                    CookieExt hl_ext_ck = new CookieExt( scenParam.current_connection.hskParams.remoteCookie );
                    msg.addExtension( hl_ext_ck );
                }

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ClientHello2"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHello" )
    protected void _ts_partialExecute_ServerHello
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHello", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHello ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                short[] cs = {
                    TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )}
                ;
                scenParam.current_connection.hskParams.generateServerKeyPair( NamedGroup.FFDHE2048 );

                ProtocolVersion svdata = new ProtocolVersion( 0x03, 0x04 );

                TLSExtension hl_ext_sv = new SupportedVersionsExt( svdata );

                TLSExtension hl_ext_ks = new KeyShareServerHello( scenParam.current_connection.hskParams.serverKeyShare );

                byte[] dataId = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8}
                ;

                Hello msg = new Hello( dataId, cs );
                msg.setTypeServerHello(  );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_ks );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHello"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHelloRetry" )
    protected void _ts_partialExecute_ServerHelloRetry
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHelloRetry", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHelloRetry ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                short[] cs = {
                    TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue(  )}
                ;

                ProtocolVersion svdata = new ProtocolVersion( 0x03, 0x04 );

                TLSExtension hl_ext_sv = new SupportedVersionsExt( svdata );

                byte[] dataId = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8}
                ;

                CookieExt hl_ext_ck = new CookieExt( dataId );

                TLSExtension hl_ext_ks = new KeyShareHelloRetry( NamedGroup.FFDHE2048 );

                Hello msg = new Hello( TLS13SpecValues.randomHelloRetryRequest, dataId, cs );
                msg.setTypeServerHello(  );
                msg.addExtension( hl_ext_sv );
                msg.addExtension( hl_ext_ck );
                msg.addExtension( hl_ext_ks );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHelloRetry"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "HelloRequest" )
    protected void _ts_partialExecute_HelloRequest
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "HelloRequest", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " HelloRequest ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                HelloRequest msg = new HelloRequest(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "HelloRequest"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerHelloDone" )
    protected void _ts_partialExecute_ServerHelloDone
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerHelloDone", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerHelloDone ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ServerHelloDone msg = new ServerHelloDone(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerHelloDone"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "CertificateRequest" )
    protected void _ts_partialExecute_CertificateRequest
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "CertificateRequest", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " CertificateRequest ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                SignatureScheme[] sah = {
                    SignatureScheme.RSA_PKCS1_SHA256
                    , SignatureScheme.ECDSA_SECP256R1_SHA256}
                ;

                SignatureAndHashAlgorithmExt hl_ext_sah = new SignatureAndHashAlgorithmExt( sah );

                String certContext = "testing CertificateRequest";

                CertificateRequest msg = new CertificateRequest( certContext.getBytes(  ) );
                msg.addExtension( hl_ext_sah );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "CertificateRequest"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Certificate" )
    protected void _ts_partialExecute_Certificate
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Certificate", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Certificate ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                HMCertificate msg = new HMCertificate(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Certificate"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "CertificateVerify" )
    protected void _ts_partialExecute_CertificateVerify
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "CertificateVerify", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " CertificateVerify ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] signtr = new byte[72];

                Random rndObj = new Random( System.currentTimeMillis(  ) );
                rndObj.nextBytes( signtr );

                CertificateVerify msg = new CertificateVerify( SignatureScheme.ECDSA_SECP256R1_SHA256, signtr );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "CertificateVerify"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ClientKeyExchange" )
    protected void _ts_partialExecute_ClientKeyExchange
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ClientKeyExchange", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ClientKeyExchange ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ClientKeyExchange msg = new ClientKeyExchange( KeyExchangeAlgorithm.DHE_RSA );

                byte[] dhv = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8
                    , 9
                    , 10
                    , 11
                    , 12
                    , 13
                    , 14
                    , 15
                    , 16
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8
                    , 9
                    , 10
                    , 11
                    , 12
                    , 13
                    , 14
                    , 15
                    , 16}
                ;
                msg.setDiffieHellmanValue( dhv );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ClientKeyExchange"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ServerKeyExchange" )
    protected void _ts_partialExecute_ServerKeyExchange
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ServerKeyExchange", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ServerKeyExchange ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] dh_p = {
                    3
                    , 4
                    , 5
                    , 6}
                ;

                byte[] dh_g = {
                    1
                    , 4
                    , 7
                    , 8
                    , 9}
                ;

                byte[] dh_Ys = {
                    9
                    , 8
                    , 7
                    , 6
                    , 5
                    , 4
                    , 3
                    , 2}
                ;

                ServerKeyExchange msg = new ServerKeyExchange( KeyExchangeAlgorithm.DH_ANON, dh_p, dh_g, dh_Ys, null );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ServerKeyExchange"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "NewSessionTicket" )
    protected void _ts_partialExecute_NewSessionTicket
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "NewSessionTicket", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " NewSessionTicket ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] tnc = "test_ticket_nonce".getBytes(  );

                byte[] tc = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8
                    , 9
                    , 10
                    , 11
                    , 12
                    , 13
                    , 14
                    , 15
                    , 16
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8
                    , 9
                    , 10
                    , 11
                    , 12
                    , 13
                    , 14
                    , 15
                    , 16}
                ;

                NewSessionTicket msg = new NewSessionTicket( 10000, 11000, tnc, tc );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "NewSessionTicket"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "EndOfEarlyData" )
    protected void _ts_partialExecute_EndOfEarlyData
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "EndOfEarlyData", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " EndOfEarlyData ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                EndOfEarlyData msg = new EndOfEarlyData(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "EndOfEarlyData"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "EncryptedExtensions" )
    protected void _ts_partialExecute_EncryptedExtensions
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "EncryptedExtensions", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " EncryptedExtensions ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                NamedGroup[] sg = {
                    NamedGroup.FFDHEtest
                    , NamedGroup.FFDHE2048}
                ;

                SupportedGroupsExt hl_ext_sg = new SupportedGroupsExt( sg );

                EncryptedExtensions msg = new EncryptedExtensions(  );
                msg.addExtension( hl_ext_sg );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "EncryptedExtensions"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "KeyUpdate" )
    protected void _ts_partialExecute_KeyUpdate
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "KeyUpdate", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " KeyUpdate ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                KeyUpdate msg = new KeyUpdate( 1 );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "KeyUpdate"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Finished" )
    protected void _ts_partialExecute_Finished
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Finished", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Finished ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                Finished msg = null;
                try
                {
                    msg = new Finished( scenParam.current_connection, MessageDirection.getMessageDirection( scenParam.current_connection.localRole, TLSDirection.SEND ) );
                    if( (msg.verify_data == null) || (msg.verify_data.length == 0) )
                        msg.setRandomVerifyData( 0x20 );

                }
                catch( Exception err )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TLSBasicTest"
                        , "Finished"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Finished"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ChangeCipherPlain" )
    protected void _ts_partialExecute_ChangeCipherPlain
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ChangeCipherPlain", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ChangeCipherPlain ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ChangeCipher msg = new ChangeCipher(  );

                RecordLayer tlsmsg = new RecordLayer( TLSContentType.CHANGE_CIPHER_SPEC, msg );
                tlsmsg.initContent( 1 );
                tlsmsg.content[0] = msg.toByteArray(  );
                scenParam.target.mayNoResponse = true;

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ChangeCipherPlain"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "ChangeCipherCrypto" )
    protected void _ts_partialExecute_ChangeCipherCrypto
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "ChangeCipherCrypto", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " ChangeCipherCrypto ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ChangeCipher msg = new ChangeCipher(  );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "ChangeCipherCrypto"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "AlertPlain" )
    protected void _ts_partialExecute_AlertPlain
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "AlertPlain", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " AlertPlain ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                Alert msg = new Alert( 1, 137 );

                RecordLayer tlsmsg = new RecordLayer( TLSContentType.ALERT, msg );
                tlsmsg.initContent( 1 );
                tlsmsg.content[0] = msg.toByteArray(  );

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "AlertPlain"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "AlertCrypto" )
    protected void _ts_partialExecute_AlertCrypto
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "AlertCrypto", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " AlertCrypto ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                Alert msg = new Alert( 1, 137 );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "AlertCrypto"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "Application" )
    protected void _ts_partialExecute_Application
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "Application", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " Application ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                ApplicationData msg = new ApplicationData( scenParam.applicationDataString.getBytes(  ) );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                scenParam.target.disconnectWithSendAlert = 0;
                scenParam.target.DisconnectWithAlert( scenParam.current_connection );
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "Application"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "HandshakeUndefinedTypeMessage" )
    protected void _ts_partialExecute_HandshakeUndefinedTypeMessage
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "HandshakeUndefinedTypeMessage", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " HandshakeUndefinedTypeMessage ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = {
                    12
                    , 34
                    , 56
                    , 83
                    , 23
                    , 45}
                ;

                HandshakeUndefinedType msg = new HandshakeUndefinedType( 37, data );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "HandshakeUndefinedTypeMessage"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "HandshakeUndefinedTypeMessage2" )
    protected void _ts_partialExecute_HandshakeUndefinedTypeMessage2
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "HandshakeUndefinedTypeMessage2", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " HandshakeUndefinedTypeMessage2 ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = {
                    12
                    , 34
                    , 56
                    , 83
                    , 23
                    , 45}
                ;

                HandshakeUndefinedType msg = new HandshakeUndefinedType( 255, data );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "HandshakeUndefinedTypeMessage2"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "MessageHash" )
    protected void _ts_partialExecute_MessageHash
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "MessageHash", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " MessageHash ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = {
                    1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8
                    , 9
                    , 10
                    , 11
                    , 12
                    , 13
                    , 14
                    , 15
                    , 16
                    , 1
                    , 2
                    , 3
                    , 4
                    , 5
                    , 6
                    , 7
                    , 8
                    , 9
                    , 10
                    , 11
                    , 12
                    , 13
                    , 14
                    , 15
                    , 16}
                ;

                HandshakeUndefinedType msg = new HandshakeUndefinedType( 254, data );

                Exception err = scenParam.msgSetContentAndSend( msg, null, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "MessageHash"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "RecordLayerUndefinedTypeMessage" )
    protected void _ts_partialExecute_RecordLayerUndefinedTypeMessage
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "RecordLayerUndefinedTypeMessage", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " RecordLayerUndefinedTypeMessage ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = {
                    12
                    , 34
                    , 56
                    , 83
                    , 23
                    , 45}
                ;

                HandshakeUndefinedType msg = new HandshakeUndefinedType( 37, data );

                RecordLayer tlsmsg = new RecordLayer( msg );
                msg.toByteArray(  );
                try
                {
                    tlsmsg.tls_type = TLSContentType.TESTTYPEONLY;
                    tlsmsg.setContent( msg.net_msg, null, scenParam.current_connection );
                }
                catch( Exception err )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TLSBasicTest"
                        , "RecordLayerUndefinedTypeMessage"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "RecordLayerUndefinedTypeMessage"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "EmptyDataAlert" )
    protected void _ts_partialExecute_EmptyDataAlert
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "EmptyDataAlert", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " EmptyDataAlert ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = new byte[0];

                RecordLayer tlsmsg = new RecordLayer( TLSContentType.ALERT, data );
                try
                {
                    tlsmsg.setContent( data, null, scenParam.current_connection );
                }
                catch( Exception err )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TLSBasicTest"
                        , "EmptyDataAlert"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }
                scenParam.target.waitFatalAlert = 20;

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "EmptyDataAlert"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }


    @jatva.lang.annotation.ScenarioMethod( jtsName = "EmptyDataHandshake" )
    protected void _ts_partialExecute_EmptyDataHandshake
        ( jatva.lang.AbstractAction _par_parameter_action )
    {
        jatva.lang.synchronization.TestManager _lv_registrar = jatva.lang.synchronization.TestManager.getRegistrar();
        _lv_registrar.scenarioMethodEnter( this, "EmptyDataHandshake", _par_parameter_action );
        try
        {
            {
                scenParam.scenarioCounter++;
                scenName = " EmptyDataHandshake ";
                DebugInfo.printMessageWithSeparator( 4, "!!!test " + scenParam.connectCounter + " scenario try " + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState );
                if( !scenParam.target.getCurrentState(  ).connected )
                    return;

                DebugInfo.printMessage( 1, "scenario start," + scenName );

                byte[] data = new byte[0];

                RecordLayer tlsmsg = new RecordLayer( TLSContentType.HANDSHAKE, data );
                try
                {
                    tlsmsg.setContent( data, null, scenParam.current_connection );
                }
                catch( Exception err )
                {
                    DebugInfo.printMessage( 1, "===Error! scenario setContent Exception: " + err );
                    scenParam.target.disconnect(  );
                    throw new jatva.lang.ScenarioConstraintViolationException
                        ( "TLSBasicTest"
                        , "EmptyDataHandshake"
                        , "Exception occured!" + scenName + "setContent"
                        );
                }
                scenParam.target.waitFatalAlert = 20;

                Exception err = scenParam.msgSend( tlsmsg, scenName );
                if( err != null )
                {
                    throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ", err );
                }
                return;
            }
        }
        catch( jatva.lang.TestException _lv_error )
        {
            throw _lv_error;
        }
        catch( Throwable _lv_error )
        {
            throw new jatva.lang.RuntimeScenarioMethodException
                ( this
                , "EmptyDataHandshake"
                , _lv_error
                );
        }
        finally
        {
            _lv_registrar.scenarioMethodExit();
        }
    }

    public static
    void main( String[] args)
    {

        String fileName = "connectInfo_mail.txt";
        if( args.length > 0 )
            fileName = args[0];

        start( fileName );
    }


    public static
    void start( String fileName)
    {

        TLSBasicTest scen = new TLSBasicTest( fileName );

        Date dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "start test " + scen.currentClassName + " " + dt1.toString(  ) );
        scen.run(  );
        dt1 = new Date(  );
        DebugInfo.logtrace( scen.scenParam.logFile, "end test: " + dt1.toString(  ) + " testCounter " + scen.scenParam.connectCounter + " scenParam.scenarioCounter " + scen.scenParam.scenarioCounter );
        scen.scenParam.logFile.close(  );
    }

}
