package ru.ispras.telecomtesk.tlsv13.HandshakeMessages;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;

public class HandshakeUndefinedType extends HandshakeMessage {
	public byte[] data;

	public HandshakeUndefinedType(byte type, byte[] data) {
		msg_type = type;
		this.data = data;
	}
	public HandshakeUndefinedType(int type, byte[] data) {
		msg_type = (byte)type;
		this.data = data;
	}
	public int getSize() {
		int size = 4;
		if(data != null)
			size += data.length;
		return size;
	}
	public int toByteArray() {
		int i = 0, j, len, res = 0;
		if(isLengthSet == false) setLength();
		// create byte array
		len = getSize();
		byte[] ba = new byte[len];
		// write msg_type, full length and version
		byte[] ba_len = ConvertTypes.hton(length);
		ba[0] = msg_type;
		System.arraycopy(ba_len, 1, ba, 1, 3);
		i=4;
		// write data
		if(data != null)
			System.arraycopy(data, 0, ba, i, data.length);
		net_msg = ba;
		return res;
	}

	public String toString() {
		int datalen = data != null ? data.length : 0;
		String res = "HandshakeMessage.UndefinedType: data " + datalen + " bytes";
		return res;
	}	
}
