package ru.ispras.telecomtesk.tlsv13.HandshakeMessages;

import java.util.ArrayList;

import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.ProtocolVersion;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.TLS13SpecValues;

public class HelloRetryRequest extends Hello
{

	public HelloRetryRequest() {
		super();
		msg_type = 2;
	}

	public HelloRetryRequest(short[] cs) {
		super(TLS13SpecValues.randomHelloRetryRequest, null, cs);
		msg_type = 2;
	}

	public HelloRetryRequest(byte[] id, short[] cs) {
		super(TLS13SpecValues.randomHelloRetryRequest, id, cs);
		msg_type = 2;
	}

	public HelloRetryRequest(ProtocolVersion ver, byte[] id, short[] cs) {
		super(ver, TLS13SpecValues.randomHelloRetryRequest, id, cs);
		msg_type = 2;
	}

	public HelloRetryRequest(ProtocolVersion ver, byte[] id, short[] cs, byte[] cm, ArrayList<TLSExtension> ext) {
		super(2,ver, TLS13SpecValues.randomHelloRetryRequest, id, cs, cm, ext);
	}

}
