package ru.ispras.telecomtesk.tlsv13.HandshakeMessages;

import java.lang.System;
import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;

public class KeyUpdate extends HandshakeMessage
{
	public byte requestUpdate;  

	public KeyUpdate() {
		this(0); 
	}

	public KeyUpdate(int flag) {
		msg_type = 24;
		requestUpdate = (byte)flag; 
	}

	@Override
	public int getSize() {
		return 5;
	}

	@Override
	public int toByteArray() {
		if(isLengthSet == false) setLength();
		// create byte array
		byte[] ba = new byte[getSize()];
		// write msg_type and full length
		byte[] ba_len = ConvertTypes.hton(length);
		ba[0] = msg_type;
		System.arraycopy(ba_len, 1, ba, 1, 3);
		ba[4] = requestUpdate;
		
		net_msg = ba;
		return 0;
	}

	@Override
	public String toString() {
		return "HandshakeMessage: type KeyUpdate, length " + length + ", flag " + requestUpdate;
	}

	@Override
	public void print() {
		DebugInfo.printMessage(1,"\nHandshake KeyUpdate Message: requestUpdate " + requestUpdate);
	}

	public static HandshakeMessage parseByteArray(byte[] msg) {
    	if(msg.length < 5) {
    		DebugInfo.printMessage(4,"===Error! KeyUpdate::parseByteArray: length failed");
    		return null;
		}
		return new KeyUpdate(msg[4]);
	}

}
