package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;

public class CookieExt extends TLSExtension
{
        // data <1..2^16-1>
	public CookieExt(byte[] data) {
		type = 44; 
		this.data = data != null ? data : new byte[0];
	}

	public CookieExt(int length, byte[] data) {
		this(data); 
		this.setLength(length);
	}

	@Override
	public int getLengthFieldSize() {
		return 2;
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
		int len;
		int lengthFieldSize = 2;
    	if(lengthExt < lengthFieldSize) {
    		DebugInfo.printMessage(4,"===Error! CookieExt::parseByteArray: Extension length failed");
    		return null;
    	}
		len = ConvertTypes.ntohs(msg,pos);
		pos += lengthFieldSize;

    	if(lengthExt != lengthFieldSize + len) {
    		DebugInfo.printMessage(4,"===Error! CookieExt::parseByteArray: Extension length wrong");
    		return null;
    	}
    	
    	byte[] extdata = new byte[len];
		System.arraycopy(msg, pos, extdata, 0, len);
		
//		params = set cookie;
		
		return new CookieExt(lengthExt, extdata);
	}
}
