package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.HandshakeMessageType;

public class EarlyDataExt extends TLSExtension
{
        // data <1..2^16-1>
	public EarlyDataExt() {
		type = 42; 
		this.data = null;
	}

	public EarlyDataExt(byte[] data) {
		type = 42; 
		this.data = data;
	}

	public EarlyDataExt(int length, byte[] data) {
		this(data); 
		this.setLength(length);
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
		byte[] extdata = null;
		
		if(lengthExt != 0) {
			extdata = new byte[lengthExt];
			System.arraycopy(msg, pos, extdata, 0, lengthExt);
		}

    	switch (HandshakeMessageType.valueOf(msg[0])) {
			case NEW_SESSION_TICKET:
    			if(lengthExt != 4) {
    				DebugInfo.printMessage(4,"===Error! EarlyDataExt::parseByteArray: Extension length " + lengthExt + ", must be 4 bytes");
    				DebugInfo.printDump(4,extdata,null);
    			}
    			break;
    		default:
    			if(lengthExt != 0) {
    				DebugInfo.printMessage(4,"===Error! EarlyDataExt::parseByteArray: Extension length " + lengthExt + ", must be 0");
    				DebugInfo.printDump(4,extdata,null);
    			}
    	}

		return new EarlyDataExt(lengthExt, extdata);
	}
}
