package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.NamedGroup;

public class KeyShareHelloRetry extends TLSExtension
{
	public NamedGroup data; 

	public KeyShareHelloRetry(NamedGroup data) {
		this.type = 51;
		this.data = data;
	}

	public KeyShareHelloRetry(int length , NamedGroup data) {
		this(data);
		this.setLength(length);
	}

	@Override
	public int getDataSize() {
		return 2;
	}

	@Override
	public void toByteArrayLengthField(byte[] msg, int position) {
	}

	@Override
	public void toByteArrayData(byte[] msg, int position) {
		int grp = data.getValue();
		msg[position++] = (byte)(grp >>> 8);
		msg[position] = (byte)grp;
	}

	@Override
	public void printData() {
		DebugInfo.printMessage(1,"  KeyShareHelloRetry");
		DebugInfo.printMessage(1,"  NamedGroup: " + data.toString());
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
    	if(lengthExt != 2) {
    		DebugInfo.printMessage(4,"===Error! KeyShareHelloRetry::parseByteArray: Extension length wrong");
    		return null;
    	}
    	
    	NamedGroup extdata = NamedGroup.valueOf(ConvertTypes.ntohs(msg, pos));
 
//		params = set cookie;
		
		return new KeyShareHelloRetry(lengthExt, extdata);
	}
}
