package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.HandshakeMessageType;

public class PostHandshakeAuthExt extends TLSExtension
{
        // data <1..2^16-1>
	public PostHandshakeAuthExt() {
		type = 49; 
		this.data = null;
	}

	public PostHandshakeAuthExt(byte[] data) {
		type = 49; 
		this.data = data;
	}

	public PostHandshakeAuthExt(int length, byte[] data) {
		this(data); 
		this.setLength(length);
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
		byte[] extdata = null;
		
		if(lengthExt != 0) {
			extdata = new byte[lengthExt];
			System.arraycopy(msg, pos, extdata, 0, lengthExt);
			DebugInfo.printMessage(4,"===Error! EarlyDataExt::parseByteArray: Extension length " + lengthExt + ", must be 0");
			DebugInfo.printDump(4,extdata,null);
		}

		return new PostHandshakeAuthExt(lengthExt, extdata);
	}
}
