package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.ConvertTypes;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;

public class PreSharedKeyServerHello extends TLSExtension
{
	public short data; // uint16

	public PreSharedKeyServerHello(short data) {
		this.type = 41;
		this.data = data;
	}

	public PreSharedKeyServerHello(int length , short data) {
		this(data);
		this.setLength(length);
	}

	@Override
	public int getDataSize() {
		return 2;
	}

	@Override
	public void toByteArrayLengthField(byte[] msg, int position) {
	}

	@Override
	public void toByteArrayData(byte[] msg, int position) {
		msg[position++] = (byte)(data >>> 8);
		msg[position] = (byte)data;
	}

	@Override
	public void printData() {
		DebugInfo.printMessage(1,"  PreSharedKeyServerHello");
		DebugInfo.printMessage(1,"  Index: " + data);
	}

	public static TLSExtension parseByteArray(int lengthExt, byte[] msg, int pos) {
    	if(lengthExt != 2) {
    		DebugInfo.printMessage(4,"===Error! PreSharedKeyServerHello::parseByteArray: Extension length wrong");
    		return null;
    	}
    	short extdata = ConvertTypes.ntohs(msg, pos);
		return new PreSharedKeyServerHello(lengthExt, extdata);
	}
}
