package ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.SignatureAndHashAlgorithm;

public class SignatureAndHashAlgorithmExt12 extends TLSExtension
{
	public SignatureAndHashAlgorithm[] data; // 0..2^16-1 bytes

	public SignatureAndHashAlgorithmExt12(SignatureAndHashAlgorithm[] sah) {
		type = 13; 
		data = sah;
	}

	@Override
	public int getLengthFieldSize() {
		return 2;
	}

	@Override
	public int getDataSize() {
		if(data != null)
			return (data.length * 2);
		else
			return 0;
	}

	@Override
	public void toByteArrayData(byte[] msg, int position) {
		if(data != null) {
			for (int j=0; j < data.length; j++) {
				msg[position++] = data[j].hash;
				msg[position++] = data[j].signature;
			}
		}
	}

	@Override
	public void printData() {
		DebugInfo.printMessage(1,"  SignatureScheme:");
		if(data != null) {
                	for(int j=0; j<data.length; j++)
				DebugInfo.printMessage(1,"    " + data[j].toString());
		}
	}
}
