package ru.ispras.telecomtesk.tlsv13.RecordProtocol;

public final class ProtocolVersion
{
	public byte major;
	public byte minor;
	
	public ProtocolVersion() {major = (byte)3; minor = (byte)3;}
	public ProtocolVersion(int a, int b) {major = (byte)a; minor = (byte)b;}
	public void setValue(int a, int b) {major = (byte)a; minor = (byte)b;}
	public boolean isTLS13() {
		return (major == 3 && minor == 4) ? true : false;
	}
	public boolean isTLS12() {
		return (major == 3 && minor == 3) ? true : false;
	}
	public boolean isTLS() {
		return (major == 3) ? true : false;
	}
	public boolean equal(ProtocolVersion a) {
		return (major == a.major && minor == a.minor);
	}
	public String toString() {
		String res = String.format("%02x", major) + String.format("%02x", minor);
		if((major == 3)&&(minor > 0)) {
			res += " [TLS 1." + (minor-1) + "]";
		}
		return res;
	}
}
