package ru.ispras.telecomtesk.tlsv13.TLSAlgorithms;

public enum AlertType {
	CLOSE_NOTIFY(0),
	UNEXPECTED_MESSAGE(10),
	BAD_RECORD_MAC(20),
	RECORD_OVERFLOW(22),
	HANDSHAKE_FAILURE(40),
	BAD_CERTIFICATE(42),
	UNSUPPORTED_CERTIFICATE(43),
	CERTIFICATE_REVOKED(44),
	CERTIFICATE_EXPIRED(45),
	CERTIFICATE_UNKNOWN(46),
	ILLEGAL_PARAMETER(47),
	UNKNOWN_CA(48),
	ACCESS_DENIED(49),
	DECODE_ERROR(50),
	DECRYPT_ERROR(51),
	PROTOCOL_VERSION(70),
	INSUFFICIENT_SECURITY(71),
	INTERNAL_ERROR(80),
	INAPPROPRIATE_FALLBACK(86),
	USER_CANCELED(90),
	MISSING_EXTENSION(109),
	UNSUPPORTED_EXTENSION(110),
	UNRECOGNIZED_NAME(112),
	BAD_CERTIFICATE_STATUS_RESPONSE(113),
	UNKNOWN_PSK_IDENTITY(115),
	CERTIFICATE_REQUIRED(116),
	NO_APPLICATION_PROTOCOL(120),
	UNKNOWN(255);
	
	public byte type;
	
	private AlertType(int type) {
		this.type = (byte)type;
	}
	public byte getValue(){
		return type;
	}
	public static AlertType valueOf(int type) {
		switch (type) {
		case 0: return CLOSE_NOTIFY;
		case 10: return UNEXPECTED_MESSAGE;
		case 20: return BAD_RECORD_MAC;
		case 22: return RECORD_OVERFLOW;
		case 40: return HANDSHAKE_FAILURE;
		case 42: return BAD_CERTIFICATE;
		case 43: return UNSUPPORTED_CERTIFICATE;
		case 44: return CERTIFICATE_REVOKED;
		case 45: return CERTIFICATE_EXPIRED;
		case 46: return CERTIFICATE_UNKNOWN;
		case 47: return ILLEGAL_PARAMETER;
		case 48: return UNKNOWN_CA;
		case 49: return ACCESS_DENIED;
		case 50: return DECODE_ERROR;
		case 51: return DECRYPT_ERROR;
		case 70: return PROTOCOL_VERSION;
		case 71: return INSUFFICIENT_SECURITY;
		case 80: return INTERNAL_ERROR;
		case 86: return INAPPROPRIATE_FALLBACK;
		case 90: return USER_CANCELED;
		case 109: return MISSING_EXTENSION;
		case 110: return UNSUPPORTED_EXTENSION;
		case 112: return UNRECOGNIZED_NAME;
		case 113: return BAD_CERTIFICATE_STATUS_RESPONSE;
		case 115: return UNKNOWN_PSK_IDENTITY;
		case 116: return CERTIFICATE_REQUIRED;
		case 120: return NO_APPLICATION_PROTOCOL;
		default: return UNKNOWN;
		}
	}

	public String toString() {
		return new StringBuilder().append(this.name()).append('<').append(type).append('>').toString();
	}

	public static String toString(int type) {
		return new StringBuilder().append(AlertType.valueOf(type).name()).append('<').append(type).append('>').toString();
	}
}
