package ru.ispras.telecomtesk.tlsv13.TLSAlgorithms;

public enum BulkCipherAlgorithm { 
	bulk_null, bulk_rc4, bulk_3des, bulk_aes128, bulk_aes256, bulk_aes128_ccm, bulk_aes128_gcm, bulk_aes256_gcm; 
	
	public CipherType getCipherType(){
		switch (this){
			case bulk_null:
			case bulk_rc4:
				return CipherType.stream;
			case bulk_3des:
			case bulk_aes128:
			case bulk_aes256:
				return CipherType.block;
			case bulk_aes128_ccm:
			case bulk_aes128_gcm:
			case bulk_aes256_gcm:
				return CipherType.aead;
			default:
				return CipherType.unknown;
		}
	}

	public int getBlockSize(){
		switch (this){
			case bulk_3des:
				return 8;
			case bulk_aes128:
			case bulk_aes256:
			case bulk_aes128_ccm:
			case bulk_aes128_gcm:
			case bulk_aes256_gcm:
				return 16;
			case bulk_null:
			case bulk_rc4:
			default:
				return 0;
		}
	}

	public int getIvSize(){
		switch (this){
			case bulk_3des:
				return 8;
			case bulk_aes128:
			case bulk_aes256:
			case bulk_aes128_ccm:
			case bulk_aes128_gcm:
			case bulk_aes256_gcm:
				return 16;
			case bulk_null:
			case bulk_rc4:
			default:
				return 0;
		}
	}
};
