package ru.ispras.telecomtesk.tlsv13.TLSAlgorithms;

public enum MACAlgorithm { 
	mac_null, 
	md5, 
	sha1, 
	sha256, 
	sha384, 
	sha512;

	public int getHashLength() {
		switch (this) {
			case mac_null:
				return 0;
			case md5:
				return 16;
			case sha1:
				return 20;
			case sha256:
				return 32;
			case sha384:
				return 48;
			case sha512:
				return 64;
			default:
				return -1;
		}
	}

	public String getHashAlgorithmName() {
		switch (this) {
			case md5:
				return "MD5";
			case sha1:
				return "SHA1";
			case sha256:
				return "SHA-256";
			case sha384:
				return "SHA-384";
			case sha512:
				return "SHA-512";
			default:
				return "";
		}
	}

	public String getMacAlgorithmName() {
		switch (this) {
			case md5:
				return "HmacMD5";
			case sha1:
				return "HmacSHA1";
			case sha256:
				return "HmacSHA256";
			case sha384:
				return "HmacSHA384";
			case sha512:
				return "HmacSHA512";
			default:
				return "";
		}
	}
}