package ru.ispras.telecomtesk.tlsv13.TLSAlgorithms;

public enum TLSContentType {
	INVALID(0),
	CHANGE_CIPHER_SPEC(20),
	ALERT(21),
	HANDSHAKE(22),
	APPLICATION(23),
	HEARTBEAT(24),
	TESTTYPEONLY(87),
	UNKNOWN(255);

	public byte type;
	
	private TLSContentType(int type) {
		this.type = (byte)type;
	}

	public byte getValue(){
		return type;
	}
	
	public static TLSContentType valueOf(byte type) {
		switch(type){
		case  0: return INVALID;
		case 20: return CHANGE_CIPHER_SPEC;
		case 21: return ALERT;
		case 22: return HANDSHAKE;
		case 23: return APPLICATION;
		case 24: return HEARTBEAT;
		case 87: return TESTTYPEONLY;
		default:
			System.out.println("===Warning! TLSContentType::valueOf: unknown type " + type);
			return UNKNOWN;
		}
	}
}
