package ru.ispras.telecomtesk.tlsv13.TestsClient.CheckTlsConnection;

//
// Simple test DSA connection with emplty client certificate list
//

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.net.Socket;
import java.util.*;
import jatva.engines.DFSMExplorer;
import java.io.IOException;
import java.lang.invoke.MethodHandles;

import jatva.lang.GraphExplorer;
import java.security.Key;
import java.security.PrivateKey;
import java.util.Date;
import java.util.Random;
import ru.ispras.telecomtesk.tlsv13.TLSState.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv13.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv13.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv13.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv13.DebugInfo;
import ru.ispras.telecomtesk.tlsv13.TLSclientSpecification.*;
import javax.net.ssl.KeyManager;
import java.security.KeyStore;
import ru.ispras.telecomtesk.tlsv13.TlsKeystore;

class TestServerHelloRetry {
	public TLSClientScenProp scenParam;
	public String scenName;
	private String currentClassName;

	public TestServerHelloRetry(String logFileName) {
		DebugInfo.debugLevel = 4;
		DebugInfo.maxDumpSize = 600;
		currentClassName = MethodHandles.lookup().lookupClass().getSimpleName();
		scenParam = new TLSClientScenProp(logFileName, currentClassName);
		
		TLSConnectionSelector sel = new TLSConnectionSelector(null,null,0,0);
		scenParam.current_connection = new TLSConnection(sel,ConnectionRole.SERVER);
	}


	public void connect() {
		scenName = " Connect ";
		DebugInfo.printMessageWithSeparator(4,"!!!scenario try," + scenName + scenParam.target.currentState);
		scenParam.connectCounter++;

		DebugInfo.printMessage(1,"scenario start," + scenName);
		try {
			scenParam.target.connect(scenParam.current_connection);
		}
		catch (jatva.lang.TestException terr) {
			DebugInfo.logtrace(scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName);
			DebugInfo.logtrace(scenParam.logFile,"===Error! scenario TestException:" + scenName + terr);
			scenParam.target.disconnect();	
			throw terr;
		}
		catch (Exception err) {
			DebugInfo.logtrace(scenParam.logFile, "===Error! connectCounter: " + scenParam.connectCounter + " scenario" + scenName);
			DebugInfo.logtrace(scenParam.logFile,"===Error! scenario failed:" + scenName + err);
			scenParam.target.disconnect();	
		}
	}

	public void ServerHelloRetry() {
		scenParam.scenarioCounter++;
		scenName = " ServerHelloRetry ";
		DebugInfo.printMessageWithSeparator(4,"!!!test " + scenParam.connectCounter + " scenario try "  + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState);
		if(!scenParam.target.getCurrentState().connected)
			return;
		DebugInfo.printMessage(1,"scenario start," + scenName);
		
		byte[] id = null;
		if(scenParam.target.last_client_hello != null) 
			id = scenParam.target.last_client_hello.sessionID;
		
		short[] cs = {TLSCipherSuite.TLS_AES_128_GCM_SHA256.getValue()
					 };
		
		HelloRetryRequest msg = new HelloRetryRequest(id, cs);

		ProtocolVersion[] svdata = {new ProtocolVersion(0x03,0x04)};
		TLSExtension hl_ext_sv = new SupportedVersionsExt(new ProtocolVersion(0x03,0x04)); // For ServerHello
		byte[] dataCookie = {10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11};
		CookieExt hl_ext_ck = new CookieExt(dataCookie);
		TLSExtension hl_ext_ks = new KeyShareHelloRetry(NamedGroup.FFDHE2048);
		DebugInfo.printMessage(1,"create Hello");
		msg.addExtension(hl_ext_sv);
		msg.addExtension(hl_ext_ck);
		msg.addExtension(hl_ext_ks);
		msg.print();
		
		Exception err = scenParam.msgSetContentAndSend(msg,null,scenName);
		if(err != null) {
			throw new RuntimeException( "scenario" + scenName + ": scenParam.msgSetContentAndSend failed ",err);
		}
		scenParam.testSuitEnd = true;
		if(scenParam.testSuitEnd) {
			scenParam.target.disconnectWithSendAlert = 0;
			scenParam.target.DisconnectWithAlert(scenParam.current_connection);
		}
		return;
	}
/*
	public void ServerHello() {
		scenParam.scenarioCounter++;
		scenName = " ServerHello ";
		DebugInfo.printMessageWithSeparator(4,"!!!test " + scenParam.connectCounter + " scenario try "  + scenParam.scenarioCounter + "," + scenName + scenParam.target.currentState);
		if(!scenParam.target.getCurrentState().connected)
			return;
		DebugInfo.printMessage(1,"scenario start," + scenName);

		
		ArrayList<RecordLayer> response;

		
		if(localks != null) {
			DebugInfo.printMessage(3,"local Keystore found");
			target.localCert = TlsKeystore.getCertificate(localks,target.sah,SignatureAlgorithm.DSA);
			target.setClientCertificateType();
			target.localPrivateKey = TlsKeystore.getPrivateKeyCert(localks, target.localCert, localKeystorePwd);
		}
		
		byte[] id = new byte[16];
		byte[] scnt = HandshakeMessage.hton(sessionIDcounter++);
		System.arraycopy(scnt, 0, id, id.length - 4, 4);
		byte[] gmt_unix_time = HandshakeMessage.hton((int)(System.currentTimeMillis() / 1000));
		System.arraycopy(gmt_unix_time, 0, id, 0, 4);
		short[] cs = {TLSCipherSuite.TLS_DHE_DSS_WITH_AES_128_CBC_SHA.getValue()
					 };
		Hello msg = new Hello(id, cs);
		msg.setTypeServerHello();

		RecordLayer tlsmsg = new RecordLayer();
		tlsmsg.msglist = new ArrayList();
		tlsmsg.msglist.add(msg);

		try {
			tlsmsg.setContent(msg,null,current_connection);
			DebugInfo.printDump(5, msg.net_msg, "ServerHello: ");
			response = target.send(tlsmsg,current_connection);
			if(null == response  ||  target.disconnectWithSendAlert != -1) {
				return false : "ServerHello send failed";
			}
		}
		catch (jatva.lang.TestException terr) {
			DebugInfo.printMessage(1,"===Error! scenario ServerHello TestException: " + terr);
			target.DisconnectWithAlert(current_connection);
			throw terr;
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario ServerHello Exception: " + err);
			target.disconnect();	
			return false : "Exception occured";
		}
		return true;
	}
	


	scenario HMCertificate() {
		DebugInfo.printMessageWithSeparator(4,"!!!scenario Certificate try. " + target.currentState);
		if(!target.getCurrentState().connected)
			return true;
		DebugInfo.printMessageWithSeparator(1,"scenario Certificate start");
		ArrayList<RecordLayer> response;
		HMCertificate msg;
		
		if(target.localCert != null) {
			DebugInfo.printMessage(3,"local certificate found");
			msg = new HMCertificate(TlsKeystore.getCertificateChainEncoded(localks,target.localCert));
		}
		else {
			DebugInfo.printMessage(3,"Warning!!! Local certificate not found");
			msg = new HMCertificate(new byte[0][]);
		}
		
		RecordLayer tlsmsg = new RecordLayer();
		tlsmsg.msglist = new ArrayList();
		tlsmsg.msglist.add(msg);
		try {
			tlsmsg.setContent(msg,null,current_connection);
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario setContent Exception: " + err);
			return false : "Exception occured! Certificate::setContent";
		}
		
		try {
			response = target.send(tlsmsg,current_connection);
			if(null == response  ||  target.disconnectWithSendAlert != -1) {
				return false : "Certificate send failed";
			}
		}
		catch (jatva.lang.TestException terr) {
			DebugInfo.printMessage(1,"===Error! scenario Certificate TestException: " + terr);
			target.DisconnectWithAlert(current_connection);
			throw terr;
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario Certificate Exception: " + err);
			target.disconnect();	
			return false : "Error! Certificate Exception occured";
		}
		return true;
	}


	scenario ChangeCipher() {
		if(!target.getCurrentState().connected)
			return true;
		DebugInfo.printMessageWithSeparator(1,"scenario ChangeCipher start");
		ArrayList<RecordLayer> response;
		ChangeCipher msg = new ChangeCipher();
		RecordLayer tlsmsg = new RecordLayer();
		tlsmsg.msglist = new ArrayList();
		tlsmsg.msglist.add(msg);
		
		try {
			tlsmsg.setContent(msg,null,current_connection);
			response = target.send(tlsmsg,current_connection);				
			if(null == response  ||  target.disconnectWithSendAlert != -1) {
				return false : "ChangeCipher send failed";
			}
		}
		catch (jatva.lang.TestException terr) {
			DebugInfo.printMessage(1,"===Error! scenario ChangeCipher TestException: " + terr);
			target.DisconnectWithAlert(current_connection);
			throw terr;
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario ChangeCipher Exception: " + err);
			target.disconnectWithSendAlert = 80;
			target.DisconnectWithAlert(current_connection);
			return false : "Exception occured";
		}
		return true;
	}

	
	scenario Finished() {
		if(!target.getCurrentState().connected)
			return true;
		DebugInfo.printMessageWithSeparator(1,"scenario Finished start");
		ArrayList<RecordLayer> response;
		Finished msg = new Finished(true);
		RecordLayer tlsmsg = new RecordLayer();
		tlsmsg.msglist = new ArrayList();
		tlsmsg.msglist.add(msg);
		DebugInfo.printMessage(4,"sessionMsgList " + target.sessionMsgList.size() + " " + target.last_client_hello_index);
		
		try {
			int res;
			DebugInfo.printMessage(5,"calcVerifyData");
			try {
				res = msg.calcVerifyData( current_connection.getWriteCurrentState().getParams(), 
					target.sessionMsgList, 
					target.last_client_hello_index, 
					target.sessionMsgList.size() - target.last_client_hello_index);
				DebugInfo.printMessage(5,"calcVerifyData return " + res);
			}
			catch (Exception err) {
				DebugInfo.printMessage(5,"===Warning! calcVerifyData failed. Create random VerifyData");
				int vd_len = msg.getVerifyDataLength(current_connection.getWriteCurrentState().getParams().cs);
				msg.verify_data = new byte[vd_len];
				Random rndObj = new Random(System.currentTimeMillis());
				rndObj.nextBytes(msg.verify_data);
			}

			tlsmsg.setContent(msg,null,current_connection);
			DebugInfo.printMessage(5,"setContent ok");
			response = target.send(tlsmsg,current_connection);				
			if(null == response  ||  target.disconnectWithSendAlert != -1) {
				if(null == response)
				DebugInfo.printMessage(5,"null == response");
				else
					DebugInfo.printMessage(5,"null != response");
				DebugInfo.printMessage(5,"target.disconnectWithSendAlert " + target.disconnectWithSendAlert);
				return false : "Finished send failed";
			}
			
			DebugInfo.printMessage(5,"Finished send ok");
		}
		catch (jatva.lang.TestException terr) {
			DebugInfo.printMessage(1,"===Error! scenario Finished TestException: " + terr);
			target.DisconnectWithAlert(current_connection);
			throw terr;
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario Finished Exception: " + err);
			target.disconnectWithSendAlert = 80;
			target.DisconnectWithAlert(current_connection);
			return false : "Exception occured";
		}
		return true;
	}
	
	scenario Application() {
		if(!target.getCurrentState().connected)
			return true;
		DebugInfo.printMessageWithSeparator(1,"scenario Application start");
		ArrayList<RecordLayer> response;
		System.out.println(applicationDataString);
		ApplicationData msg = new ApplicationData(applicationDataString.getBytes());
		RecordLayer tlsmsg = new RecordLayer();
		tlsmsg.msglist = new ArrayList();
		tlsmsg.msglist.add(msg);
		DebugInfo.printMessage(4,"sessionMsgList " + target.sessionMsgList.size() + " " + target.last_client_hello_index);
		
		try {
			tlsmsg.setContent(msg,null,current_connection);
			DebugInfo.printMessage(5,"setContent ok");
			response = target.send(tlsmsg,current_connection);
			DebugInfo.printMessage(5,"ApplicationData send ok. Disconnect");
			target.disconnectWithSendAlert = 0;
			target.DisconnectWithAlert(current_connection);
		}
		catch (jatva.lang.TestException terr) {
			DebugInfo.printMessage(1,"===Error! scenario Application TestException: " + terr);
			target.DisconnectWithAlert(current_connection);
			throw terr;
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario Application Exception: " + err);
			target.disconnectWithSendAlert = 80;
			target.DisconnectWithAlert(current_connection);
			return false : "Exception occured";
		}
		return true;
	}
*/

	public void StopServer() {
		try {
			DebugInfo.printMessage(1,"Server is stopping");
			scenParam.target.stop();
			DebugInfo.printMessage(1,"Server has stopped");
		}
		catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! scenario StopServer: " + err);
		}
		return;
	}


	public static void main(String[] args) {
		String fileName = "connectInfo_mail.txt";
//		String fileName = "connectInfo_http.txt";
//		String fileName = "connectInfo_java.txt";
		if (args.length > 0 )
			fileName = args[0];
		start(fileName);
	}
	
	
	public static void start(String fileName) {
		TestServerHelloRetry scen = new TestServerHelloRetry(fileName);

		Date dt1 = new Date();
		DebugInfo.logtrace(scen.scenParam.logFile,"start test " + scen.currentClassName + " " + dt1.toString());
		
		scen.connect();
//		scen.ServerHello();
		scen.ServerHelloRetry();
//		scen.Finished();
		
		
		scen.StopServer();
		dt1 = new Date();
		DebugInfo.logtrace(scen.scenParam.logFile,"end test: " + dt1.toString() + " testCounter " + scen.scenParam.connectCounter + " scenarioCounter "  + scen.scenParam.scenarioCounter);
		scen.scenParam.logFile.close();
	}
}